<?php
if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
global $_G;
define('BOAN_BUYCREDIT_NAME', 'plugin/boan_buycredit');
try{
    $vars = $_G['cache']['plugin']['boan_buycredit'];
    
    C::m('#boan_payment#payment');
    if($_GET['formhash'] != FORMHASH){
        throw new Exception(lang(BOAN_BUYCREDIT_NAME,'IllegalAccess'),201);
    }
    
    if($_GET['op'] == 'getorder'){
        
        $payment_para = $_G['cache']['plugin']['boan_payment'];
        $alipay = $wxpay = 0;
        if($payment_para){
            $alipay = intval($payment_para['alipay_ok']);
            $wxpay = intval($payment_para['wxpay_ok']);
        }
        
        if($alipay + $wxpay == 0){
            throw new Exception(lang(BOAN_BUYCREDIT_NAME,'notfound'),202);
        }
        
        for($i=0; $i<=3; $i++){
            $credittype = $vars['credittype'.$i];
            if(!empty($credittype)){
                $extcredit['credittype'] = $credittype;
                $extcredit['title'] =  $_G['setting']['extcredits'][$credittype]['title'];
                $extcredit['balance'] = getuserprofile('extcredits'.$credittype);
                $extcredit['rate'] = empty($vars['rate'.$i]) ? 1 : $vars['rate'.$i];
                $extcredit['minamount'] = intval($vars['minamount'.$i]);
                
                if(!empty(trim($vars['bonus'.$i]))){
                    $bonus = explode(',', $vars['bonus'.$i]);
                    $bonus_list = [];
                    foreach ($bonus as $v){
                        $t = explode('=', $v);
                        
                        $bonus_list[] = ['amount'=>$t[0],'bonus'=>$t[1]];
                    }
                    $extcredit['bonus_list'] = $bonus_list;
                }
                $extcredits_list[] = $extcredit;
            }
        }
        
        $extcredit_ct = intval($_GET['extcreditamount']);
        $credittype = intval($_GET['credittype']);
        
        foreach ($extcredits_list as $v){
            if($v['credittype'] == $credittype){
                $extcredit = $v;
                break;
            }
        }
        
        if(empty($extcredit)){
            throw new Exception(lang(BOAN_BUYCREDIT_NAME, 'buy_donot'),203);
        }
        $bonus = 0;
        foreach ($extcredit['bonus_list'] as $v){
            if($extcredit_ct == $v['amount']){
                $amount = $v['amount'] / $extcredit['rate'];
                $credit_ct =  $v['amount'] + $v['bonus'];
                $bonus = $v['bonus'];
                break;
            }
        }
      
        if(empty($bonus)){
            $amount = $extcredit_ct / $extcredit['rate'];
            $credit_ct =  $extcredit_ct;
        }
       
        $subject = lang(BOAN_BUYCREDIT_NAME, 'buy_pay').$credit_ct.$extcredit['title'];
        $body = lang(BOAN_BUYCREDIT_NAME, 'buy_pay').$credit_ct.$extcredit['title']
        .(!empty($bonus) ? '('.lang(BOAN_BUYCREDIT_NAME, 'buy_bonus').$bonus.$extcredit['title'].')' : '')
        .','.lang(BOAN_BUYCREDIT_NAME, 'buy_total').(number_format($amount,2)).lang(BOAN_BUYCREDIT_NAME, 'buy_yuan');
        $create_time = dgmdate(TIMESTAMP);
        $expire_time = dgmdate(TIMESTAMP + 3600);
        
        if(empty($amount)){
            throw new Exception(lang(BOAN_BUYCREDIT_NAME, 'buy_zero'),204);
        }elseif($amount < $extcredit['minamount']){
            throw new Exception(lang(BOAN_BUYCREDIT_NAME, 'buy_toolow'),205);
        }elseif($amount > 30000){
            throw new Exception(lang(BOAN_BUYCREDIT_NAME, 'buy_toohign'.'30000'),206);
        }
        
        $order_id = C::m('#boan_payment#payment')->createOrder('boan_buycredit',$subject,$amount,$body,'home.php?mod=spacecp&ac=plugin&op=credit&id=boan_buycredit:buycredit',3600,['credit_ct'=>$credit_ct,'credittype'=>$credittype]);
        $alipayurl = $wxpayurl = '';
        if($alipay && !$payment_para['alipay_cashier'] && empty($payment_para['alipay_code'])){
            $alipayurl = C::m('#boan_payment#payment')->getPayUrl($order_id,'alipay');
        }
        if($wxpay && empty($payment_para['wxpay_code'])){
            $wxpayurl = C::m('#boan_payment#payment')->getPayUrl($order_id,'wxpay');
        }
        
        $info = array(
            'code' => 200,
            'msg' => 'Ok',
            'orderid' => $order_id,
            'alipay' => $alipayurl,
            'wxpay' => $wxpayurl,
        );
        
    }
}catch (Exception $e){
    $info = array(
        'code' => $e->getCode(),
        'msg' => $e->getMessage(),
    );
}
echo json_encode(boan_paymentBase::iconv($info,CHARSET,'utf-8'));
exit();