<?php
if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
global $_G;
loadcache('boan_group',true);
$cache = $_G['cache']['boan_group'];
define('BOAN_GROUP_NAME', 'plugin/boan_group');
try{
    C::m('#boan_payment#payment');
    if($_GET['formhash'] != FORMHASH){
        throw new Exception(lang(BOAN_GROUP_NAME,'IllegalAccess'),201);
    }
    
    if($_GET['op'] == 'getorder'){
        
        $itemid = intval($_GET['itemid']);
        
        if(empty($_G['uid'])){
            throw new Exception(lang(BOAN_GROUP_NAME,'logout'),202);
        }
        
        if(!isset($cache['list'][$itemid])){
            throw new Exception(lang(BOAN_GROUP_NAME,'pay_group_noitem'),203);
        }
        
        $item = $cache['list'][$itemid];
        
        if(empty($item['allow'])){
            throw new Exception(lang(BOAN_GROUP_NAME,'pay_group_stepsale'),204);
        }
        
        $payment_para = $_G['cache']['plugin']['boan_payment'];
        $alipay = $wxpay = 0;
        if($payment_para){
            $alipay = intval($payment_para['alipay_ok']);
            $wxpay = intval($payment_para['wxpay_ok']);
        }
        
        if($alipay + $wxpay == 0){
            throw new Exception(lang(BOAN_GROUP_NAME,'pay_group_nopay'),205);
        }
        
        checkgroup($item['gid']);
        
        
        $subject = lang(BOAN_GROUP_NAME, 'pay_into_buy').$item['title'];
        $amount = !empty($item['preferential']) ? $item['preferential'] : $item['price'];
        $body = lang(BOAN_GROUP_NAME,'pay_into_buy').$item['title'].lang(BOAN_GROUP_NAME,'pay_into_deadline').$item['deadline'].lang(BOAN_GROUP_NAME,'pay_into_total').number_format($amount,2).lang(BOAN_GROUP_NAME,'pay_into_yuan');
        if($item['credittype'] && $item['credit']){
            $body .=  ' '.lang(BOAN_GROUP_NAME, 'pay_into_give').$item['credit'].$_G['setting']['extcredits'][$item['credittype']]['title'];
        }
        
        $order_id = C::m('#boan_payment#payment')->createOrder('boan_group',$subject,$amount,$body,'',3600,['item' => serialize($item)]);
        
        $alipayurl = $wxpayurl = '';
        
        if($alipay && empty($payment_para['alipay_cashier']) && empty($payment_para['alipay_code'])){
            $alipayurl = C::m('#boan_payment#payment')->getPayUrl($order_id,'alipay');
        }
        if($wxpay && empty($payment_para['wxpay_code'])){
            $wxpayurl = C::m('#boan_payment#payment')->getPayUrl($order_id,'wxpay');
        }
        $info = array(
            'code' => 200,
            'msg' => 'Ok',
            'orderid' => $order_id,
            'alipay' => $alipayurl,
            'wxpay' => $wxpayurl,
        );
        
    }
    
}catch (Exception $e){
    $info = array(
        'code' => $e->getCode(),
        'msg' => $e->getMessage(),
    );
}

echo json_encode(boan_paymentBase::iconv($info,CHARSET,'utf-8'));
exit();

function checkgroup($groupidnew){
    global  $_G;
    $uid = $_G['uid'];
    
    $member =  C::t('common_member')->fetch($uid, false, 1);
    if(!$member) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nouser'));
    }
    $tableext = isset($member['_inarchive']) ? '_archive' : '';
    
    $membermf = C::t('common_member_field_forum'.$tableext)->fetch($uid);
    $membergroup = C::t('common_usergroup')->fetch($member['groupid']);
    $member = array_merge($member, (array)$membermf, $membergroup);
    $member['groupterms'] = dunserialize($member['groupterms']);
    
    $groupid = $member['groupid'];
    
    $group = C::t('common_usergroup')->fetch($groupidnew);
    
    if(!$group) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nogroup'));
    }
    if($member['adminid'] > 0) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nobuy'));
    }
    
    if($member['groupid'] == $groupidnew){
        if(empty($member['groupterms']['main'])){
            throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nobuy1'));
        }
        
    }
    return 1;
}