<?php
if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
    exit('Access Denied');
}
define('BOAN_GROUP_NAME', 'plugin/boan_group');

global $_G;
loadcache('boan_group',true);
$cache = $_G['cache']['boan_group'];

if(!submitcheck('artificial_submit')){
    
    showtips(lang(BOAN_GROUP_NAME, 'artificial'));
    cpheader();
    !is_array($cache['list']) && ($cache['list'] = array());
    foreach ($cache['list'] as $k => $v){
        if(empty($v['allow'])){
            unset($cache['list'][$k]);
            continue;
        }
        
        $cache['list'][$k]['description'] = explode('|', $cache['list'][$k]['description']);
    }
    
    uasort($cache['list'], function($a,$b){
        return $a['order'] - $b['order'];
    });
        
    if(empty($cache['list'])){
        cpmsg(lang(BOAN_GROUP_NAME, 'pay_group_noitem'), '', 'error');
    }
    
    $items = [];
    foreach ($cache['list'] as $k => $v){
        $items[] = [$k,$v['title'].'('.($v['preferential'] >0 ? $v['preferential'] : $v['price']).lang(BOAN_GROUP_NAME, 'pay_into_yuan').')'];
    }
    
    showformheader('plugins&operation=config&do='.$pluginid.'&pmod=artificial');
    showtableheader('','','',9);
    showtagheader('tbody', '',true);
    
    
   showsetting('UID', 'userid','','number',0,0,lang(BOAN_GROUP_NAME, 'admin_artificial_uid'));
    
   showsetting(lang(BOAN_GROUP_NAME, 'admin_artificial_vip'),
     array('itemid',
        $items    
     ),
     '1','select',0,0,lang(BOAN_GROUP_NAME, 'admin_artificial_vip_comment')
     );
    
   showsetting(lang(BOAN_GROUP_NAME, 'admin_artificial_paymethod'),
       array('paymethod',
           [['1',lang(BOAN_GROUP_NAME, 'admin_artificial_alipay')],
               ['2',lang(BOAN_GROUP_NAME, 'admin_artificial_wxpay')]]
       ),
       '1','select',0,0,lang(BOAN_GROUP_NAME, 'admin_artificial_paymethod_comment')
       );
    
    
    showtagfooter('tbody');
    showsubmit('artificial_submit');
    showtablefooter();
    showformfooter();
}else{
    
    try{
        $uid = intval($_GET['userid']);
        $itemid = intval($_GET['itemid']);
        $item = $cache['list'][$itemid];
        $paymethod = intval($_GET['paymethod']) == 1 ? 'alipay' : 'wxpay';
        checkgroup($uid,$item['gid']);
       
        $subject = lang(BOAN_GROUP_NAME, 'pay_into_buy').$item['title'];
        $amount = !empty($item['preferential']) ? $item['preferential'] : $item['price'];
        $body = lang(BOAN_GROUP_NAME,'pay_into_buy').$item['title'].lang(BOAN_GROUP_NAME,'pay_into_deadline').$item['deadline'].lang(BOAN_GROUP_NAME,'pay_into_total').number_format($amount,2).lang(BOAN_GROUP_NAME,'pay_into_yuan');
        if($item['credittype'] && $item['credit']){
            $body .=  ' '.lang(BOAN_GROUP_NAME, 'pay_into_give').$item['credit'].$_G['setting']['extcredits'][$item['credittype']]['title'];
        }
        $oldid = $_G['uid'];
        $_G['uid'] = $uid;
        $order_id = C::m('#boan_payment#payment')->createOrder('boan_group',$subject,$amount,$body,'plugin.php?id=boan_group&op=grecord',3600,['item' => serialize($item)]);
        C::m('#boan_payment#payment')->updateOrder($order_id,['pay_method' => $paymethod,'status' => 1,'trade_id' => $order_id,'pay_time' => TIMESTAMP]);
        C::m('#boan_payment#payment')->pluginNotify($order_id,'payNotify');
        
        $_G['uid'] = $oldid;
        
        cpmsg(lang(BOAN_GROUP_NAME, 'admin_artificial_succeed'), 'action=plugins&operation=config&do='.$pluginid.'&pmod=artificial', 'succeed');
        
    }catch (Exception $e){
        cpmsg($e->getMessage(), 'action=plugins&operation=config&do='.$pluginid.'&pmod=artificial', 'error');
    }
}

function checkgroup($uid,$groupidnew){
    global  $_G;
    
    $member =  C::t('common_member')->fetch($uid, false, 1);
    if(!$member) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nouser'));
    }
    $tableext = isset($member['_inarchive']) ? '_archive' : '';
    
    $membermf = C::t('common_member_field_forum'.$tableext)->fetch($uid);
    $membergroup = C::t('common_usergroup')->fetch($member['groupid']);
    $member = array_merge($member, (array)$membermf, $membergroup);
    $member['groupterms'] = dunserialize($member['groupterms']);
    
    $groupid = $member['groupid'];
    
    $group = C::t('common_usergroup')->fetch($groupidnew);
    
    if(!$group) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nogroup'));
    }
    if($member['adminid'] > 0) {
        throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nobuy'));
    }
    
    if($member['groupid'] == $groupidnew){
        if(empty($member['groupterms']['main'])){
            throw new Exception(lang(BOAN_GROUP_NAME, 'pay_group_nobuy1'));
        }
        
    }
    return 1;
}