<?php
if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

require_once "pay/wxpay/WxPay.Config.php";
require_once "pay/wxpay/lib/WxPay.Api.php";
define('BOAN_PAYMENT_NAME', 'plugin/boan_payment');
global $_G;

if(empty($_G['cache']['plugin'])){
    loadcache('plugin');
}

$vars = $_G['cache']['plugin']['boan_payment'];
C::m('#boan_payment#payment');

if(strpos($_G['siteurl'], 'source') !== FALSE){
    $_G['siteurl'] = substr($_G['siteurl'],0,strpos($_G['siteurl'], 'source'));
}

if($_GET['op'] == 'getopenid'){
    $appid = $vars['wxpay_mini_appid'];
    $secret = $vars['wxpay_mini_appsecret'];
    $code = $_GET['code'];
    $url = "https://api.weixin.qq.com/sns/jscode2session?appid=$appid&secret=$secret&js_code=$code&grant_type=authorization_code";
    
    $data =  dfsockopen($url);
    $data = json_decode($data,true);
    if(empty($data)){
        $result = ['status' => '201','errmsg' => 'requestUrlErr'];
    }else if(empty($data['openid'])){
        $result = ['status' => '202','errmsg' => $data['errmsg']];
    }else{
        $result = ['status' => '200','openid' => $data['openid']];
    }
    
    echo json_encode($result);
}

if($_GET['op'] == 'getpayment'){
    
    $openid = $_GET['openid'];
    try{
        $order_id = dhtmlspecialchars($_GET['orderid']);
        if(empty($order_id) || !($order = C::m('#boan_payment#payment')->getOrder($order_id))){
            throw new Exception(lang(BOAN_PAYMENT_NAME, 'order_err4'));
        }
        if($order['status'] != 0){
            throw new Exception(lang(BOAN_PAYMENT_NAME, 'order_err6'));
        }
        
        $biz_content=[
            'out_trade_no' => $order_id,
            'total_amount' => $order['amount'],
            'subject' => $order['subject'],
        ];
        $backurl = '';
        if($order['return_url']){
            $backurl = $_G['siteurl'].$order['return_url'];
        }else{
            $backurl = $_G['siteurl'].'home.php?mod=spacecp&ac=plugin&id=boan_payment:user_order';
        }
        $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
        $tools = new JsApiPay();
        $input = new WxPayUnifiedOrder();
        $input->SetBody($biz_content['subject']);
        $input->SetOut_trade_no($biz_content['out_trade_no']);
        $input->SetTotal_fee(intval($biz_content['total_amount']*100));
        $input->SetTime_start(date("YmdHis"));
        $input->SetTime_expire(date("YmdHis", time() + 600));
        $input->SetNotify_url($_G['siteurl'].'source/plugin/boan_payment/pay/wxpay/notify.php');
        $input->SetProduct_id($biz_content['out_trade_no']);
        $input->SetTrade_type("JSAPI");
        $input->SetOpenid($openid);
        
        $order1 = WxPayApi::unifiedOrder($tools->Config, $input);
        
        $jsApiParameters = $tools->GetJsApiParameters($order1);
        $jsApiParameters['biz'] = array('orderid' => $order_id,'subject' => $order['subject'],
            'body' => $order['body'],'amount' => $order['amount'],'createtime' => dgmdate($order['create_time'],'dt'));
        echo json_encode(boan_paymentBase::iconv($jsApiParameters,CHARSET));
        
    }catch (Exception $e){
        $t['code'] = $e->getCode();
        $t['message'] = $e->getMessage();
        echo json_encode(boan_paymentBase::iconv($t,CHARSET));
    }
}

class JsApiPay{
    public $Config;
    private $Vars;
    function __construct(){
        global $_G;
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
        $vars['wxpay_appid'] =  $vars['wxpay_mini_appid'];;
        $vars['wxpay_secert'] = $vars['wxpay_mini_appsecret'];
        $this->Vars = $vars;
        $this->Config = new WxPayConfig($vars);
    }
    
    
    public function GetJsApiParameters($UnifiedOrderResult)
    {
        if(!array_key_exists("appid", $UnifiedOrderResult)
            || !array_key_exists("prepay_id", $UnifiedOrderResult)
            || $UnifiedOrderResult['prepay_id'] == "")
        {
            
            if(!empty($UnifiedOrderResult['return_code'])){
                throw new WxPayException($UnifiedOrderResult['return_code'].'|'.$UnifiedOrderResult['return_msg']);
            }else {
                throw new WxPayException($UnifiedOrderResult['err_code'].'|'.$UnifiedOrderResult['err_code_des']);
            }
            
        }
        
        $jsapi = new WxPayJsApiPay();
        $jsapi->SetAppid($UnifiedOrderResult["appid"]);
        $timeStamp = time();
        $jsapi->SetTimeStamp("$timeStamp");
        $jsapi->SetNonceStr(WxPayApi::getNonceStr());
        $jsapi->SetPackage("prepay_id=" . $UnifiedOrderResult['prepay_id']);
        
        $config = $this->Config;;
        $jsapi->SetPaySign($jsapi->MakeSign($config));
        $parameters = $jsapi->GetValues();
        return $parameters;
    }
    
    private function ToUrlParams($urlObj)
    {
        $buff = "";
        foreach ($urlObj as $k => $v)
        {
            if($k != "sign"){
                $buff .= $k . "=" . $v . "&";
            }
        }
        
        $buff = trim($buff, "&");
        return $buff;
    }
    
}