<?php
if (!defined('IN_DISCUZ')) {
    exit('Access denid');
}
require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'autoloader.php';

class alipay{
    private $aop;
    private $vars;
    function __construct(){
        global $_G;
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
        $this->vars = $vars;
        if(!empty($vars['alipay_code'])){
            return 0;
        }
        
        $this->aop = new AopClient ();
        $this->aop->gatewayUrl = $vars['alipay_gateway'];
        $this->aop->appId =  $vars['alipay_appid'];
        $this->aop->rsaPrivateKey =  $vars['alipay_private_key'];
        $this->aop->alipayrsaPublicKey = $vars['alipay_public_key'];
        
        if(empty($this->aop->appId) || trim( $this->aop->appId)==""){
            throw new Exception(lang(P_PAYMENT, 'alipay_err1'));
        }
        if(empty($this->aop->rsaPrivateKey)||trim($this->aop->rsaPrivateKey)==""){
            throw new Exception(lang(P_PAYMENT, 'alipay_err2'));
        }
        if(empty($this->aop->alipayrsaPublicKey)||trim($this->aop->alipayrsaPublicKey)==""){
            throw new Exception(lang(P_PAYMENT, 'alipay_err3'));
        }
        
        if(empty($this->aop->gatewayUrl)||trim($this->aop->gatewayUrl)==""){
            throw new Exception(lang(P_PAYMENT, 'alipay_err4'));
        }
    }
    function isActivation(){
        global $_G;
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
     
        return $vars['alipay_ok'];
    }
    function getQrcode($biz_content){
        global $_G;
        if(empty($this->aop)){
            return false;
        }
      
        $request = new AlipayTradePrecreateRequest();
        $request->setBizContent(boan_paymentBase::json_encode($biz_content));
        $request->setNotifyUrl($_G['siteurl'].'source/plugin/boan_payment/pay/alipay/notify.php');
        $rtn = $this->aop->execute($request)->{$this->aop->getApiResponseName($request)};
        if($rtn->code == 10000){
            return $rtn->qr_code;
        }else{
            throw new Exception(var_export($rtn,true));
        }
       
        return false;
    }
    
    function getPage($biz_content){
        global $_G;
        if(empty($this->aop)){
            return false;
        }
        $biz_content['product_code'] = "FAST_INSTANT_TRADE_PAY";
        $request = new AlipayTradePagePayRequest();
        $request->setReturnUrl($_G['siteurl'].'source/plugin/boan_payment/pay/alipay/return.php');
        $request->setBizContent(boan_paymentBase::json_encode($biz_content));
        return $this->aop->pageExecute($request,'get');
    }
    
    function getWap($biz_content){
        global $_G;
        if(empty($this->aop)){
            return false;
        }
        $biz_content['product_code'] = "QUICK_WAP_PAY";
        $request = new AlipayTradeWapPayRequest();
        $request->setReturnUrl($_G['siteurl'].'source/plugin/boan_payment/pay/alipay/return.php');
        $request->setNotifyUrl($_G['siteurl'].'source/plugin/boan_payment/pay/alipay/notify.php');
        $request->setBizContent(boan_paymentBase::json_encode($biz_content));
       
        $user_agent = strtolower($_SERVER['HTTP_USER_AGENT']);
        if(strpos($user_agent,'micromessenger') === false){
            echo $this->aop->pageExecute($request);
            die();
        }else{
            return $this->aop->pageExecute($request,'get');
        }
      
    }
    
    
    
    function verify($arr){
        $result = $this->aop->rsaCheckV1($arr, $this->aop->alipayrsaPublicKey, 'RSA2');
        
        return $result;
    }
    
    function Query($order_id){
        $order = C::t('#boan_payment#boan_payment_order')->fetch($order_id);
        if(empty($order)){
            return 0;
        }
        if(!empty($this->vars['alipay_code'])){
            return $order['status'];
        }
        $request = new AlipayTradeQueryRequest();
        $request->setBizContent(boan_paymentBase::json_encode(['out_trade_no'=>$order_id]));
        try{
           $rtn = $this->aop->execute($request)->{$this->aop->getApiResponseName($request)};
        }catch (Exception $e){
            return 0;
        }
        if($rtn->code != 10000){
            return 0;
        }
        
        if(($rtn->trade_status == 'TRADE_SUCCESS' || $rtn->trtrade_status == 'TRADE_FINISHED') && $rtn->total_amount == $order['amount']){
            $lockid = 'pay_'.$order_id;
            if(!discuz_process::islocked($lockid)){
                C::m('#boan_payment#payment')->updateOrder($order_id,['pay_method'=>'alipay','status'=>1,'pay_time'=>strtotime($rtn->send_pay_date),'trade_id'=>$rtn->trade_no]);
                C::m('#boan_payment#payment')->log($rtn->out_trade_no,2,'alipay',lang(P_PAYMENT, 'order_info1'), 2,$rtn);
                C::m('#boan_payment#payment')->pluginNotify($order_id,'payNotify');
                discuz_process::unlock($lockid);
            }
            return 1;
        }
     
        return 0;
    }
}