<?php
if (!defined('IN_DISCUZ')) {
    exit('Access denid');
}

require_once "EpayCore.php";

class wxpay{
    
    private $Vars;
    
    private $epay;
    
    private $config;
    
    function __construct(){
        
        global $_G;
        
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
        
        $this->Vars = $vars;
        
        if(empty($vars['epay_pid']) || empty($vars['epay_key']) || $vars['eapy_url']){
            
            throw new Exception(lang(P_PAYMENT, 'epay_lost_params'));
        }
        
        $this->config = array('pid' => $vars['epay_pid'],'key' => $vars['epay_key'],'apiurl' =>  $vars['epay_url']);
        $this->epay = new EpayCore($this->config);
    }
    
    function getQrcode($biz_content){
        //throw new Exception(lang(P_PAYMENT, 'epay_no_qcode'));
        return '';
    }
    
    function Query($order_id){
        
        $order = C::t('#boan_payment#boan_payment_order')->fetch($order_id);
        
        if(empty($order)){
            return 0;
        }
        
        try{
            $result = $this->epay->queryOrder($order_id);
            if($result['status'] == 1){
                
                $lockid = 'pay_'.$order_id;
                if(!discuz_process::islocked($lockid)){
                    C::m('#boan_payment#payment')->updateOrder($order_id,['pay_method'=>'wxpay','status'=>1,'pay_time'=>strtotime($result['endtime']),'trade_id'=>$result['trade_no']]);
                    C::m('#boan_payment#payment')->log($result['trade_no'],2,'wxpay',lang(P_PAYMENT, 'order_info1'), 2,$result);
                    C::m('#boan_payment#payment')->pluginNotify($order_id,'payNotify');
                    discuz_process::unlock($lockid);
                }
                return 1;
            }
            
        }catch (Exception $e){
            
        }
        return 0;
    }
    
    function getPage($biz_content){
        global $_G;
        return $this->getWap($biz_content);
    }
    
    function getWap($biz_content){
        
        global $_G;
        
        try {
            
            $order = C::m('#boan_payment#payment')->getOrder($biz_content['out_trade_no']);
            
            if(!C::m('#boan_payment#payment')->isPay($order['order_id'])){
                
                throw new Exception(lang(P_PAYMENT, 'order_err6'));
                
            }
            
            $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
            
            $baseUrl =  !empty($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : $_G['siteurl'];
            
            $backurl = '';
            
            if($order['return_url']){
                
                $backurl = $_G['siteurl'].$order['return_url'];
                
            }else{
                
                $backurl = $_G['siteurl'].'home.php?mod=spacecp&ac=plugin&id=boan_payment:user_order';
                
            }
            
            $notify_url = $_G['siteurl'].'source/plugin/boan_payment/pay/epay/notify.php';
            
            $data = array(
                "pid" => $this->config['pid'],
                "type" => 'wxpay',
                "notify_url" => $notify_url,
                "return_url" => $backurl,
                "out_trade_no" => $biz_content['out_trade_no'],
                "name" => $biz_content['subject'],
                "money"	=> $biz_content['total_amount'],
                
            );
            
            return  $this->epay->getPayLink($data);
            
        } catch (Exception $e) {
            throw new Exception("errcode:{$e->getCode()},errmsg:{$e->getMessage()}");
        }
    }
    
    function isActivation(){
        return $this->Vars['wxpay_ok'];
    }
}
