<?php
if (!defined('IN_DISCUZ')) {
    exit('Access denid');
}

require_once "hupijiao_api.php";
class alipay{
    private  $Vars;
    private  $appid;
    private  $appsecret;
    private  $plugin_id;
    private  $gateway;
    function __construct(){
        global $_G;
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
        $this->Vars      = $vars;
        $this->appid     = $vars['hpjpay_alipay_appid'];
        $this->appsecret = $vars['hpjpay_alipay_appsecret'];
        $this->plugin_id = 'boan_payment';
        $this->gateway   = $vars['hpjpay_gateway'] ? $vars['hpjpay_gateway'] : $vars['hpjpay_wx_gateway'];
    }
    
    function isActivation(){
        return $this->Vars['alipay_ok'];
    }
    
    function Query($order_id){
        $order = C::t('#boan_payment#boan_payment_order')->fetch($order_id);
        if(empty($order)){
            return 0;
        }
        try{
            $request=array(
                'appid'     => $this->appid, 
                'out_trade_order'=> $order['order_id'], 
                'time'      => time(),
                'nonce_str' => $this->getNonceStr()
            );
            $hashkey             = $this->appsecret;
            $request['hash']     = XH_Payment_Api::generate_xh_hash($request,$hashkey);
            $url                 =  $this->gateway.'query.html';
            
            $response            = XH_Payment_Api::http_post($url, http_build_query($request));
           
            $result              = $response ? boan_paymentBase::json_decode($response) : null;
            if(!$result || !$result['data']){
                throw new Exception('Internal server error:'.$response,500);
            }
            
            $result = $result['data'];
            
            if($result['status'] == 'OD'){
                $lockid = 'pay_'.$order_id;
                if(!discuz_process::islocked($lockid)){
                    C::m('#boan_payment#payment')->updateOrder($order_id,['pay_method'=>'alipay','status'=>1,'pay_time'=>strtotime($result['paid_date']),'trade_id'=>$result['transaction_id']]);
                    C::m('#boan_payment#payment')->log($result['transaction_id'],2,'alipay',lang(P_PAYMENT, 'order_info1'), 2,$result);
                    C::m('#boan_payment#payment')->pluginNotify($order_id,'payNotify');
                    discuz_process::unlock($lockid);
                }
                return 1;
            }
        }catch (Exception $e){
            
        }
        return 0;
    }
    
    
    function getQrcode($biz_content){
        global $_G;
        try {
            $order = C::m('#boan_payment#payment')->getOrder($biz_content['out_trade_no']);
             if(!C::m('#boan_payment#payment')->isPay($order['order_id'])){
                 throw new Exception(lang(P_PAYMENT, 'order_err6'));
             }
            $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
            $data = array(
                'version'   => '1.1',
                'lang'       => 'zh-cn',
                'plugins'   => $this->plugin_id,
                'appid'     => $this->appid,
                'trade_order_id'=> $biz_content['out_trade_no'],
                'payment'   => 'alipay',
                'total_fee' => $biz_content['total_amount'],
                'title'     => $biz_content['subject'],
                'time'      => time(),
                'attach'    => 'alipay',
                'notify_url'=>  $_G['siteurl'].'source/plugin/boan_payment/pay/hupijiao/pcnotify.php',
                'nonce_str' => $this->getNonceStr(),
            );
            
            $hashkey = $this->appsecret;
            
            $data['hash']     = XH_Payment_Api::generate_xh_hash($data,$hashkey);
            $url              =  $this->gateway.'do.html';
            $response     = XH_Payment_Api::http_post($url, json_encode($data));
            $result       = $response ? boan_paymentBase::json_decode($response) : null;
            if(!$result){
                throw new Exception('Internal server error',500);
            }
            $hash         = XH_Payment_Api::generate_xh_hash($result,$hashkey);
            if(!isset( $result['hash']) || $hash!=$result['hash']){
                throw new Exception('Invalid sign!',40029);
            }
            if($result['errcode'] !=0 ){
                throw new Exception($result['errmsg'],$result['errcode']);
            }
            
            return  $result['url_qrcode'];
            
        } catch (Exception $e) {
            throw new Exception("errcode:{$e->getCode()},errmsg:{$e->getMessage()}");
        }
    }
    
    function getWap($biz_content){
        global $_G;
        try {
            $order = C::m('#boan_payment#payment')->getOrder($biz_content['out_trade_no']);
            if(!C::m('#boan_payment#payment')->isPay($order['order_id'])){
                throw new Exception(lang(P_PAYMENT, 'order_err6'));
            }
            $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
            
            $baseUrl =  !empty($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : $_G['siteurl'];
            
            $backurl = '';
            
            if($order['return_url']){
                $backurl = $_G['siteurl'].$order['return_url'];
            }else{
                $backurl = $_G['siteurl'].'home.php?mod=spacecp&ac=plugin&id=boan_payment:user_order';
            }
            
            $data = array(
                'version'   => '1.1',
                'lang'       => 'zh-cn',
                'plugins'   => $this->plugin_id,
                'appid'     => $this->appid,
                'trade_order_id'=> $biz_content['out_trade_no'],
                'payment'   => 'alipay',
                'total_fee' => $biz_content['total_amount'],
                'title'     => $biz_content['subject'],
                'time'      => time(),
                'notify_url'=> $_G['siteurl'].'source/plugin/boan_payment/pay/hupijiao/notify.php',
                'return_url'=> $backurl,
                'callback_url' => $baseUrl,
                'attach' => 'alipay',
                'nonce_str' => $this->getNonceStr(),
            );
            
            $hashkey = $this->appsecret;
            
            $data['hash']     = XH_Payment_Api::generate_xh_hash($data,$hashkey);
            $url              =  $this->gateway.'do.html';
            $response         = XH_Payment_Api::http_post($url, json_encode($data));
            $result           = $response ? boan_paymentBase::json_decode($response) : null;
            if(!$result){
                throw new Exception('Internal server error',500);
            }
            $hash         = XH_Payment_Api::generate_xh_hash($result,$hashkey);
            if(!isset( $result['hash']) || $hash!=$result['hash']){
                throw new Exception('Invalid sign!',40029);
            }
            if($result['errcode'] != 0 ){
                throw new Exception($result['errmsg'],$result['errcode']);
            }
         
            return  $result['url'];
            
        } catch (Exception $e) {
            throw new Exception("errcode:{$e->getCode()},errmsg:{$e->getMessage()}");
        }
    }
    
    public  function getNonceStr($length = 32)
    {
        $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
        $str ="";
        for ( $i = 0; $i < $length; $i++ )  {
            $str .= substr($chars, mt_rand(0, strlen($chars)-1), 1);
        }
        return $str;
    }
}