<?php
if (!defined('IN_DISCUZ')) {
    exit('Access denid');
}
require_once "WxPay.Config.php";
require_once "lib/WxPay.Api.php";
class wxpay{
    private $Config;
    private $Vars;
    function __construct(){
        global $_G;
        if(empty($_G['cache']['plugin'])){
            loadcache('plugin');
        }
        
        $vars = $_G['cache']['plugin']['boan_payment'];
        $this->Vars = $vars;
        if(!empty($vars['wxpay_code'])){
            return 0;
        }
        $this->Config = new WxPayConfig($vars);
     
    }
    
    function isActivation(){
        return $this->Vars['wxpay_ok'];
    }
    
    function Query($order_id){
        $order = C::t('#boan_payment#boan_payment_order')->fetch($order_id);
        if(empty($order)){
            return 0;
        }
        if(!empty($this->Vars['wxpay_code'])){
            return $order['status'];
        }
       try{
           $input = new WxPayOrderQuery();
           $input-> SetOut_trade_no($order['order_id']);
           $config = $this->Config;
           $result = WxPayApi::orderQuery($config, $input);
           if($result['trade_state'] == 'SUCCESS'){
               $lockid = 'pay_'.$order_id;
               if(!discuz_process::islocked($lockid)){
                   C::m('#boan_payment#payment')->updateOrder($order_id,['pay_method'=>'wxpay','status'=>1,'pay_time'=>strtotime($result['time_end']),'trade_id'=>$result['transaction_id']]);
                   C::m('#boan_payment#payment')->log($result['transaction_id'],2,'wxpay',lang(P_PAYMENT, 'order_info1'), 2,$result);
                   C::m('#boan_payment#payment')->pluginNotify($order_id,'payNotify');
                   discuz_process::unlock($lockid);
               }
               return 1;
           }
       }catch (Exception $e){
       }
       
       return 0;
        
    }
    
    function getQrcode($biz_content){
        global $_G;
        try{
            $order = C::m('#boan_payment#payment')->getOrder($biz_content['out_trade_no']);
            if(!C::m('#boan_payment#payment')->isPay($order['order_id'])){
                throw new Exception(lang(P_PAYMENT, 'order_err6'));
            }
            
            if(strlen($biz_content['subject'])>120){
                $biz_content['subject'] = cutstr($biz_content['subject'],100);
            }
            $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
            $input = new WxPayUnifiedOrder();
            $input->SetBody($biz_content['subject']);
            $input->SetOut_trade_no($biz_content['out_trade_no']);
            $input->SetTotal_fee(intval($biz_content['total_amount']*100));
            $input->SetTime_start(date("YmdHis"));
            $input->SetTime_expire(date("YmdHis", time() + 600));
            $input->SetNotify_url($_G['siteurl'].'source/plugin/boan_payment/pay/wxpay/notify.php');
            $input->SetTrade_type("NATIVE");
            $input->SetProduct_id($biz_content['out_trade_no']);
         
            $result = WxPayApi::unifiedOrder($this->Config, $input);
            
            if(empty($result['code_url'])){
                throw new Exception(json_encode(boan_paymentBase::iconv($result,'utf-8',CHARSET),JSON_UNESCAPED_UNICODE));
            }
            return  $result['code_url'];
        } catch(Exception $e) {
            throw new Exception($e->getMessage(),$e->getCode());
        }
        
    }
    
    function getWap($biz_content){
        global $_G;
        $biz_content = boan_paymentBase::iconv($biz_content,CHARSET,'utf-8');
        if (stripos($_SERVER['HTTP_USER_AGENT'],'MicroMessenger')) {            
            return 'source/plugin/boan_payment/pay/wxpay/jspay.php?order_id='.$biz_content['out_trade_no'];
        }else{
            if(!empty($this->Vars['wxpay_close_h5'])){
                
                $VUE = '$';
                $urllink = $_G['siteurl'].$_SERVER['REQUEST_URI'];
                include template('boan_payment:wxh5Close');
                exit();
            }
            $input = new WxPayUnifiedOrder();
            $input->SetBody($biz_content['subject']);
            $input->SetOut_trade_no($biz_content['out_trade_no']);
            $input->SetTotal_fee(intval($biz_content['total_amount']*100));
            $input->SetTime_start(date("YmdHis"));
            $input->SetTime_expire(date("YmdHis", time() + 600));
            $input->SetNotify_url($_G['siteurl'].'source/plugin/boan_payment/pay/wxpay/notify.php');
            $input->SetProduct_id($biz_content['out_trade_no']);
            $input->SetTrade_type("MWEB");
            $result = WxPayApi::unifiedOrder($this->Config, $input);
            if(empty($result['mweb_url'])){
                showmessage(json_encode(boan_paymentBase::iconv($result,'utf-8',CHARSET),JSON_UNESCAPED_UNICODE));
            }           
            return $result['mweb_url'];
        }
        
    }
    
    private function ToUrlParams($urlObj)
    {
        $buff = "";
        foreach ($urlObj as $k => $v)
        {
            $buff .= $k . "=" . $v . "&";
        }
        
        $buff = trim($buff, "&");
        return $buff;
    }
    
   
    
}