<?php
//插件设置
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

include_once('bphp.func.php');

global $_G;
$input = filter($_GET);


if($_G['groupid'] != 1){
	exit('您没有操作权限，请使用管理员帐号登陆！');
}

if(submitcheck('formhash')){
	//读取配置
	if($input['ac'] == 'getConfig'){
		$configForm = bphpConfig();
		$groups = DB::fetch_all('select grouptitle,groupid from %t where groupid not in(4,5,6,7,8)',array('common_usergroup',0),'groupid'); //用户组
		foreach($configForm as $k=>$v){
			if($v === 'true'){
				$v = true;
			}
			if($v === 'false'){
				$v = false;
			}
			$configForm[$k] = $v;
		}
		die(json_encode(['sta'=>1,'msg'=>'success','configForm'=>$configForm,'groups'=>$groups]));
	}
	
	//修改配置
	if($input['ac'] == 'setConfig'){
		savecache('bphp_clouds',null);
		
		$config = $input['config'];

		
		//判断ftp_connect 函数是否存在
		if($config['storageType'] == 'ftp'){
			if(!function_exists('ftp_connect')){
				die(json_encode(['sta'=>0,'msg'=>'请确认是否php ftp扩展是否已安装！']));
			}
		}
		
		//文件目录
		if(!file_exists('source/plugin/bphp_clouds/upload/tempdir')){
			mkdir('source/plugin/bphp_clouds/upload/tempdir',0777,true);
		}

		foreach($config as $k=>$v){
			$valType = 'string';
			
			if(is_array($v)){
				$v = json_encode($v);
				$valType = 'array';
			}
			Db::insert('bphp_clouds_config',['key'=>$k,'val'=>$v,'valType'=>$valType],true,true);
		}
		
		bphpConfig();
		die(json_encode(['sta'=>1,'msg'=>'success']));
	}
	
	//用户列表
	if($input['ac'] == 'userList'){
		$pageSize = 10;
		$startNum = ($input['page']-1)*$pageSize;

		$sql = 'select * from %t limit '.$startNum.','.$pageSize;
		$parm = array('bphp_clouds_user');
		$userList = DB::fetch_all($sql,$parm); //用户组
		
		foreach($userList as $k=>$v){
			$v['fastLink'] = json_decode($v['fastLink']);
			$v['username'] = DB::result_first('SELECT username FROM %t where uid=%d',array('common_member',$v['uid']));
			$v['headimg'] = $_G['siteurl'].'uc_server/avatar.php?uid='.$v['uid'].'&size=small';
			$v['addtime'] = date('Y-m-d H:i',$v['addtime']);
			$userList[$k] = $v;
		}
		
		//总人数
		if($input['page'] == 1){
			$total = DB::result_first('SELECT COUNT(*) FROM %t',array('bphp_clouds_user'));
		}
		
		die(json_encode(['sta'=>1,'msg'=>'success','data'=>$userList,'total'=>$total,'pageSize'=>$pageSize]));
	}
	
	//修改空间大小
	if($input['ac'] == 'editSpace'){
		$spaceSize = $input['spaceSize']*1024*1024;
		Db::update('bphp_clouds_user',['spaceSize'=>$spaceSize],['uid'=>$input['uid']]);
		die(json_encode(['sta'=>1,'msg'=>'修改成功','spaceSize'=>$spaceSize]));
	}
	
	//删除用户
	if($input['ac'] == 'delUser'){
		$sta = 1;
		$msg  = '';

		$allFile = DB::fetch_all('select path,position from %t where uid=%d',array('bphp_clouds',$input['uid']));

		//尝试删除其它平台文件
		$aliyunFile = array();
		$qiniuFile = array();
		$ftpFile = array();
		foreach($allFile as $k=>$v){
			if($v['position'] == 'aliyun'){
				$aliyunFile[] = $v['path'];
			}
			if($v['position'] == 'qiniu'){
				$qiniuFile[] = $v['path'];
			}
			if($v['position'] == 'ftp'){
				$ftpFile[] = $v['path'];
			}
		}

		//aliyun
		if(count($aliyunFile)>0){
			$fi = 0;
			include_once('aliyunOss.func.php');
			foreach($aliyunFile as $k=>$v){
				$res = aliyunOssDel($v,$input['uid']);
				if($res['sta'] != 1){
					$fi++;
				}
			}

			if($fi>0){
				$sta = 0;
				$msg .= '阿里云存储有'.$fi.'个文件删除失败，需要手动删除，目录地址：bphpClouds/'.$input['uid'].'<br/>';
			}
		}

		//qiniu
		if(count($qiniuFile)>0){
			$fi = 0;
			include_once('qiniuOss.func.php');
			foreach($qiniuFile as $k=>$v){
				$res = qiniuDelFile($v);
				if($res['sta'] != 1){
					$fi++;
				}
			}

			if($fi>0){
				$sta = 0;
				$msg .= '七牛云有'.$fi.'个文件删除失败，需要手动删除，所有文件名前辍为：bphpClouds/'.$input['uid'].'的文件<br/>';
			}
		}
		
		//ftp
		if(count($ftpFile)>0){
			$fi = 0;

			//ftp连接
			$ftpConnect = ftpConnect();
			if($ftpConnect['sta'] == 0){
				$sta = 0;
				$msg .= 'ftp有'.count($ftpFile).'个文件删除失败，需要手动删除，目录地址：bphpClouds/'.$input['uid'].'<br/>';
			}else{
				$conn_id = $ftpConnect['id'];
			}

			foreach($ftpFile as $k=>$v){
				$res = ftp_delete($conn_id, $v);
				ftp_delete($conn_id, $v.'_s.jpg');
				if(!$res){
					$fi++;
				}
			}

			if($fi>0){
				$sta = 0;
				$msg .= 'ftp有'.$fi.'个文件删除失败，需要手动删除，目录地址：bphpClouds/'.$input['uid'].'<br/>';
			}
		}

		//删除本地
		$path = 'source/plugin/bphp_clouds/upload/'.$input['uid'].'/';
		if(file_exists($path)){
			$res = deldir('source/plugin/bphp_clouds/upload/'.$input['uid'].'/');
			if(!$res){
				$sta = 0;
				$msg .='问题2：删除本地文件失败！';
			}
		}
		
		//删除记录
		DB::delete('bphp_clouds',['uid' => $input['uid']]);
		DB::delete('bphp_clouds_user',['uid' => $input['uid']]);
		DB::delete('bphp_clouds_class',['uid' => $input['uid']]);
		

		if($sta == 0){
			die(json_encode(['sta'=>$sta,'msg'=>$msg]));
		}
		
		die(json_encode(['sta'=>$sta,'msg'=>'删除成功！']));
	}
	
	
	
	//文件列表
	if($input['ac'] == 'fileList'){
		$page = isset($input['page'])?$input['page']:1;
		
		$sNum = 0;
		$pageLen = 100; 
		$sNum = ($page-1)*$pageLen;
		$map = ['所有文件'];
		
		//文件列表
		$sql = 'SELECT * FROM %t  ORDER BY id DESC LIMIT %d,%d ';
		$param = array('bphp_clouds',$sNum,$pageLen);
		
		//最大页数
		$totalSql = 'SELECT COUNT(*) FROM %t';
		$totalParam = $param;
		
		if(isset($input['uid']) && !empty($input['uid'])){
			$sql = 'SELECT * FROM %t where uid=%d ORDER BY id DESC LIMIT %d,%d ';
			$param = array('bphp_clouds',$input['uid'],$sNum,$pageLen);
			$totalSql ='SELECT COUNT(*) FROM %t where uid=%d';
			
			$map[] = DB::result_first('SELECT username FROM %t where uid=%d',array('common_member',$input['uid'])); 
		}
		
		
		$fList = DB::fetch_all($sql,$param);
		$total = DB::result_first($totalSql,$totalParam);
		
		foreach($fList as $k=>$v){
			$v['thumb'] = fileThumb($v); //缩略图
			
			//链接s
			if($v['position'] == 'local'){
				$v['link'] = $_G['siteurl'].$v['path']; 
				$v['path'] = $_G['siteurl'].$v['path'];
			}else{
				$v['link'] = $v['path']; 
			}

			$fList[$k] = $v;
		}
		
		die(json_encode(['sta'=>1,'msg'=>'success','data'=>$fList,'total'=>$total,'map'=>$map]));
	}
	
	
	//删除文件
	if($input['ac'] == 'delFile'){
	
		//用户存储空间
		$capacity = DB::result_first('select capacity from %t where uid=%d',array('bphp_clouds_user',$input['uid']));
		$file = DB::fetch_first('SELECT path,id,position,size FROM %t WHERE uid=%d AND id in (%n)',array('bphp_clouds',$input['uid'],$ids));
		
		
		if($file['position'] == 'aliyun'){
			include_once('aliyunOss.func.php');
			aliyunOssDel($file['path']);
		}
		
		if($file['position'] == 'local'){
			if(file_exists($file['path'])){
				@unlink($file['path']);
			}
			if(file_exists($v['path'].'_s.jpg')){
				@unlink($file['path'].'_s.jpg');
			}
		}
		
		$capacity = $capacity-$file['size'];
		
		Db::delete('bphp_clouds','uid='.$input['uid'].' and id='.$input['fid']);
		Db::update('bphp_clouds_user',['capacity'=>$capacity],['uid'=>$input['uid']]);
		
		die(json_encode(['sta'=>1,'msg'=>'删除成功！']));
	}
	
	
}
	
	

if($input['url'] == 'config'){
	include template('bphp_clouds:admin/config');
	return true;
}

if($input['url'] == 'member'){
	include template('bphp_clouds:admin/member');
	return true;
}

if($input['url'] == 'space'){
	include template('bphp_clouds:admin/space');
	return true;
}


//文件下载
//http://www.dz2.com/plugin.php?id=bphp_clouds:admin&url=download&fid=76
if($_GET['url'] == 'download'){
	include_once('bphp_file.class.php');
	$file = DB::fetch_first('SELECT * FROM %t WHERE id=%d',array('bphp_clouds',$_GET['fid']));
	$f = new bphp_file();
	$f->download($file['path'],$file['name']);
	return false;
}



?>