<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

//开发状态
$bphp_debug = false;
if($bphp_debug){
	$ver = time();
}else{
	global $_G;
	$ver = $_G['setting']['plugins']['version']['bphp_clouds'];
}


//安全过滤
function filter($data){
	foreach($data as $k=>$v){
		if(is_array($v)){
			$v = filter($v);
		}else{
			$v = strip_tags($v);
			$data[$k] = addslashes($v);
		}
	}
	return $data;
}

//生成缩略图
function CreateSmallImage($OldImagePath, $NewImagePath, $NewWidth=100, $NewHeight=100){
	// 取出原图，获得图形信息getimagesize参数说明：0(宽),1(高),2(1gif/2jpg/3png),3(width="638" height="340")
	$OldImageInfo = getimagesize($OldImagePath);

	if ( $OldImageInfo[2] == 1 ) $OldImg = @imagecreatefromgif($OldImagePath);

	elseif ( $OldImageInfo[2] == 2 ) $OldImg = @imagecreatefromjpeg($OldImagePath);

	else $OldImg = @imagecreatefrompng($OldImagePath);

	// 创建图形,imagecreate参数说明：宽,高
	$NewImg = imagecreatetruecolor( $NewWidth, $NewHeight );

	//创建色彩,参数：图形,red(0-255),green(0-255),blue(0-255)
	$white = ImageColorAllocate( $NewImg, 255, 255, 255 ); //白色
	imagefill($NewImg, 0, 0, $white);

	//新图形高宽处理
	$WriteNewWidth = $NewHeight*($OldImageInfo[0] / $OldImageInfo[1]); //要写入的高度
	$WriteNewHeight = $NewWidth*($OldImageInfo[1] / $OldImageInfo[0]); //要写入的宽度


	//以$NewHeight为基础,如果新宽小于或等于$NewWidth,则成立

	if ($WriteNewWidth <= $NewWidth ) {
	$WriteNewWidth = $WriteNewWidth; //用判断后的大小
	$WriteNewHeight = $NewHeight; //用规定的大小
	$WriteX = floor( ($NewWidth-$WriteNewWidth) / 2 ); //在新图片上写入的X位置计算
	$WriteY = 0;
	} else {
	$WriteNewWidth = $NewWidth; // 用规定的大小
	$WriteNewHeight = $WriteNewHeight; //用判断后的大小
	$WriteX = 0;
	$WriteY = floor( ($NewHeight-$WriteNewHeight) / 2 ); //在新图片上写入的X位置计算
	}

	//旧图形缩小后,写入到新图形上(复制),imagecopyresized参数说明：新旧, 新xy旧xy, 新宽高旧宽高
	@imageCopyreSampled( $NewImg, $OldImg, $WriteX, $WriteY, 0, 0, $WriteNewWidth, $WriteNewHeight, $OldImageInfo[0], $OldImageInfo[1] );

	//保存文件
	@imagejpeg($NewImg, $NewImagePath, 100);

	//结束图形
	@imagedestroy($NewImg);

	return true;
}


//文件缩略图
//$file 
//buildThumb 图片生成缩略图
function fileThumb($file,$buildThumb = true){
	
	//图片
	if(in_array($file['type'],array('jpg','png','gif','jpeg'))){
		if($buildThumb){
			
			//云存储图片缩略
			if($file['position'] == 'aliyun'){
				return $file['path'].'?x-oss-process=image/resize,m_mfit,h_65,w_0&v='.$file['addtime'];
			}
			
			if($file['position'] == 'qiniu'){
				return $file['path'].'?imageView2/0/w/65/h/65&v='.$file['addtime'];
			}
			
			if($file['position'] == 'ftp'){
				$pConfig = bphpConfig();
				return $pConfig['ftp']['url'].$file['path'].'_s.jpg?v='.$file['addtime'];
			}

			if($file['position'] == 'local'){
				
				if(!file_exists($file['path'])){
					return 'source/plugin/bphp_clouds/static/style/img/failed.png';
				}

				if(!file_exists($file['path'].'_s.jpg')){
					CreateSmallImage($file['path'],$file['path'].'_s.jpg',65,65);
				}
				return $file['path'].'_s.jpg?v='.$file['addtime'];
			}

		}else{
			return 'source/plugin/bphp_clouds/static/style/fileIcon/img.png';
		}
	}
	
	//其它图片
	if($file['type'] == 'svg' || $file['type'] == 'webp'){
		if($file['position'] == 'ftp'){
			$pConfig = bphpConfig();
			return $pConfig['ftp']['url'].$file['path'];
		}else{
			return $file['path'];
		}
	}


	//视频
	if(in_array($file['type'],array('avi','mp4','m4v','wmv','mpg','mpeg','mov','rm','ram','flv','swf','ogv'))){
		
		//视频封面
		if($file['position'] == 'aliyun' && $file['type'] == 'mp4'){
			return $file['path'].'?x-oss-process=video/snapshot,t_7000,f_jpg,w_0,h_65,m_fast';
		}
		
		if($file['position'] == 'qiniu' && $file['type'] == 'mp4'){
			return $file['path'].'?vframe/jpg/offset/2/w/0/h/65';
		}

		return 'source/plugin/bphp_clouds/static/style/fileIcon/video.png';
	}
	
	//音频
	if(in_array($file['type'],array('mp3','aac','ogg','vorbis','opus','wav','flac','ape','alac','3ga'))){
		return 'source/plugin/bphp_clouds/static/style/fileIcon/audio.png';
	}
	
	if(file_exists('source/plugin/bphp_clouds/static/style/fileIcon/'.$file['type'].'.png')){
		return 'source/plugin/bphp_clouds/static/style/fileIcon/'.$file['type'].'.png';
	}else{
		return 'source/plugin/bphp_clouds/static/style/fileIcon/other.png';
	}
}

//删除
//$path 文件夹或文件路径 例：aa/bb/cc/
function deldir($path){
   //如果是目录则继续
   if(is_dir($path)){
		$p = scandir($path);
		foreach($p as $val){
			if($val !="." && $val !=".."){
				if(is_dir($path.$val)){
				deldir($path.$val.'/');
				@rmdir($path.$val.'/');
				}else{
				  //如果是文件直接删除
					unlink($path.$val);
				}
			}
		}
		@rmdir(substr($path,0,-1));
		return true;
	}else{//如果是文件
		if(file_exists($path)){
			$res = unlink($path);
			return $res;
		}else{
			return false;
		}
	}
}


//远程下载文件
//$url 文件下载地址
//$save_dir 存储路径
//存储名称
function getFile($url, $save_dir = '', $filename = '') {
    //创建保存目录
    if (!file_exists($save_dir) && !mkdir($save_dir, 0777, true)) {
        return false;
    }

    //获取远程文件所采用的方法
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); // 禁止 cURL 验证对等证书
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); //禁止检查服务器SSL证书
	$content = curl_exec($ch);
	curl_close($ch);

	//文件大小
    $size = strlen($content);
    
	//写入文件
    $fp2 = @fopen($save_dir . $filename, 'a');
    fwrite($fp2, $content);
    fclose($fp2);
	
	//销毁
    unset($content, $url);
	
	//返回
    return array(
        'file_name' => $filename,
        'save_path' => $save_dir.$filename,
        'file_size' => $size
    );
}


//文件大小单位
function sizeUint($size){
	$source = $size;
	$size = ceil($size/1024);
	$unit = 'KB';
	if($size>=1024){
		$size = ceil($size/1024*100)/100;
		$unit = 'MB';
	}
	if($size>=1024){
		$size = ceil($size/1024*100)/100;
		$unit = 'G';
	}
	return array('source'=>$source,'size'=>$size,'unit'=>$unit,'formatText'=>$size.$unit);
}



//加密函数
function lock($txt){
  global $_G;
  $key = $_G['config']['security']['authkey'];
  $chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
  $nh = rand(0,64);
  $ch = $chars[$nh];
  $mdKey = md5($key.$ch);
  $mdKey = substr($mdKey,$nh%8, $nh%8+7);
  $txt = base64_encode($txt);
  $tmp = '';
  $i=0;$j=0;$k = 0;
  for ($i=0; $i<strlen($txt); $i++) {
    $k = $k == strlen($mdKey) ? 0 : $k;
    $j = ($nh+strpos($chars,$txt[$i])+ord($mdKey[$k++]))%64;
    $tmp .= $chars[$j];
  }
  return urlencode($ch.$tmp);
}


//解密函数
function unlock($txt){
	global $_G;
	$key = $_G['config']['security']['authkey'];
	$txt = urldecode($txt);
	$chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-=+";
	$ch = $txt[0];
	$nh = strpos($chars,$ch);
	$mdKey = md5($key.$ch);
	$mdKey = substr($mdKey,$nh%8, $nh%8+7);
	$txt = substr($txt,1);
	$tmp = '';
	$i=0;$j=0; $k = 0;
	for ($i=0; $i<strlen($txt); $i++) {
	$k = $k == strlen($mdKey) ? 0 : $k;
	$j = strpos($chars,$txt[$i])-$nh - ord($mdKey[$k++]);
	while ($j<0) $j+=64;
	$tmp .= $chars[$j];
	}
	return base64_decode($tmp);

}


//获取配置
function bphpConfig(){
	global $_G;
	loadcache('bphp_clouds');
	$_G['cache']['bphp_clouds'];
	if($_G['cache']['bphp_clouds']){
		return $_G['cache']['bphp_clouds'];
	}
	
	$data = DB::fetch_all('SELECT * FROM %t',['bphp_clouds_config']);
	$config = array();
	foreach($data as $k=>$v){
		if($v['valType'] == 'array'){
			$v['val'] = json_decode($v['val'],true);
		}
		$config[$v['key']] = $v['val'];
	}
	
	savecache('bphp_clouds',$config);
	return $config;
}



//判断是否为手机
function is_mobile(){
	// 如果有HTTP_X_WAP_PROFILE则一定是移动设备
  if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
    return true;
  } 

  // 如果via信息含有wap则一定是移动设备,部分服务商会屏蔽该信息
  if (isset($_SERVER['HTTP_VIA'])) { 
    // 找不到为flase,否则为true
    return stristr($_SERVER['HTTP_VIA'], "wap") ? true : false;
  } 

  // 脑残法，判断手机发送的客户端标志,兼容性有待提高。其中'MicroMessenger'是电脑微信
  if (isset($_SERVER['HTTP_USER_AGENT'])) {
    $clientkeywords = array('nokia','sony','ericsson','mot','samsung','htc','sgh','lg','sharp','sie-','philips','panasonic','alcatel','lenovo','iphone','ipod','blackberry','meizu','android','netfront','symbian','ucweb','windowsce','palm','operamini','operamobi','openwave','nexusone','cldc','midp','wap','mobile','MicroMessenger'); 
    // 从HTTP_USER_AGENT中查找手机浏览器的关键字
    if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
      return true;
    } 
  } 

  // 协议法，因为有可能不准确，放到最后判断
  if (isset ($_SERVER['HTTP_ACCEPT'])) { 
    // 如果只支持wml并且不支持html那一定是移动设备
    // 如果支持wml和html但是wml在html之前则是移动设备
    if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
      return true;
    } 
  } 
  return false;

}


//连接ftp
function ftpConnect(){
	$pConfig = bphpConfig();
	$ftp_server = $pConfig['ftp']['server']; //ip 或 域名
	$ftp_port = $pConfig['ftp']['port']; // 指定FTP服务器端口号  
	$ftp_username = $pConfig['ftp']['username'];  //ftp帐号
	$ftp_password = $pConfig['ftp']['password'];   //ftp密码

	$conn_id = ftp_connect($ftp_server,$ftp_port);
	if (!$conn_id) {
		return ['sta'=>0,'msg'=>'无法连接到FTP服务器'];
		exit;  
	} 

	$login_result = ftp_login($conn_id, $ftp_username, $ftp_password);  
	if (!$login_result) {
		return ['sta'=>0,'msg'=>'无法登录到FTP服务器'];
		ftp_close($conn_id);  
		exit;
	}
	
	if($pConfig['closeFtpPasv'] == 'false'){
		ftp_pasv($conn_id, true); // 启用被动模式
	}

	return ['sta'=>1,'id'=>$conn_id] ;
}


//获取当前目录下的所有子id
function getGroupId($pid){
	$uid = DB::result_first('SELECT uid FROM %t WHERE cid=%d',array('bphp_clouds_class',$pid));
	$userClass = DB::fetch_all('SELECT cid,pid FROM %t WHERE uid=%d',array('bphp_clouds_class',$uid));

	$pClass = array();
	$waitSortClass = array();
	foreach($userClass as $k=>$v){
		if($v['pid'] == 0){
			$pClass[$v['cid']] = $v;
		}else{
			$waitSortClass[] = $v;
		}
	}

	$sortClass = cpSort($pClass,$waitSortClass);
	$ccids = array($pid);
	foreach($sortClass as $k=>$v){
		if(in_array($v['pid'],$ccids)){
			$ccids[] = $v['cid'];
		}
	}
	return $ccids;
}

//子父排序 
//$sortClass 已排序
//$waitSortClass 待排序
function cpSort($sortClass,$waitSortClass){
	foreach($waitSortClass as $k=>$v){
		if(isset($sortClass[$v['pid']])){
			$sortClass[$v['cid']] = $v;
			unset($waitSortClass[$k]);
		}
	}
	if(count($waitSortClass)>0){
		return cpSort($sortClass,$waitSortClass);
	}else{
		return $sortClass;
	}
}





    		  	  		  	  		     	  	 			    		   		     		       	   	 		    		   		     		       	   	 		    		   		     		       	   				    		   		     		       	   	 	    		   		     		       	 	        		   		     		       	 	        		   		     		       	    	 	    		   		     		       	  	  		    		   		     		       	 	   	    		   		     		       	   	       		   		     		       	  		 	     		   		     		       	  	   	    		   		     		       	    		     		   		     		       	  	 		     		   		     		       	    			    		   		     		       	  	 		     		   		     		       	  		 	     		   		     		       	 	   	    		   		     		       	  			      		   		     		       	  	        		   		     		       	  	  	     		   		     		       	 	        		 	      	  		  	  		     	
?>