<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
//分类类

class bphp_classify{
	
	//当前位置
	//$cid 分类cid
	public function map($cid){
		if($cid == 0){
			return [];
		}
		
		$class  = DB::fetch_first('SELECT * FROM %t WHERE cid=%d', ['bphp_clouds_class',$cid]);
		$map = [['cid'=>$class['cid'],'c_name'=>$class['c_name']]];
		
		//只有一级
		if($class['pid'] == 0){
			return $map;
		}
		
		//大于1级
		if($class['pid'] > 0){
			return $this->findParents($class['pid'],$map);
		}
	
	}
	
	
	//查找所有上级
	public function findParents($cid,$map){
		$class = DB::fetch_first('SELECT * FROM %t WHERE cid=%d', ['bphp_clouds_class',$cid]);
		array_unshift($map, ['cid'=>$class['cid'],'c_name'=>$class['c_name']]);
		if($class['pid'] > 0){
			return $this->findParents($class['pid'],$map);
		}else{
			return $map;
		}
	}
	

	//验证获取位置
	public function checkMap($cid,$tpid,$map=[],$pids=[]){
		$class  = DB::fetch_first('SELECT cid,pid,c_name FROM %t WHERE cid=%d', ['bphp_clouds_class',$cid]);
		$map[] = $class;
		
		if($cid == $tpid){
			return  $map;
		}

		$pids[] = $class['pid'];
		if($class['pid'] == 0 || $class['pid'] == $tpid){

			if(!in_array($tpid,$pids)){
				return false;
			}
			
			if($cid != $tpid){
				$top = DB::fetch_first('SELECT cid,pid,c_name FROM %t WHERE cid=%d', ['bphp_clouds_class',$tpid]);
				if($top){
					$map[] = $top;
				}
			}
			
			$map = array_reverse($map);
			return  $map;
		}
		
		return $this->checkMap($class['pid'],$tpid,$map,$pids);

	}
	
	

	
	
	
	//查找所有子级id包含自身id
	//$cid 数字或数组
	public function allCcid($cid){
		global $_G;
		$classify = DB::fetch_all('SELECT cid,pid FROM %t WHERE uid=%d', ['bphp_clouds_class',$_G['uid']]);
		$classify = $this->setLevel($classify);
		
		if(is_array($cid)){
			$cids = $cid;
		}else{
			$cids = array($cid);
		}
		
		foreach($classify as $k=>$v){
			if(in_array($v['pid'],$cids)){
				$cids[] = $v['cid'];
			}
		}
		return $cids;
	}
	
	
	
	//分类路径
	public function  cPath($cid,$path = array()){
		global $_G;
		if($cid == 0){
			return 'source/plugin/bphp_clouds/upload/'.$_G['uid'];
		}
		
		$class = DB::fetch_first('SELECT cid,pid FROM %t WHERE cid=%d', ['bphp_clouds_class',$cid]);
		array_unshift($path,$class['cid']);
		//循环
		if($class['pid']>0){
			return $this->cPath($class['pid'],$path);
		}

		$path = implode('/',$path);
		$path = 'source/plugin/bphp_clouds/upload/'.$_G['uid'].'/'.$path;
		return $path;
	}
	
	//目录树
	//$selCid 已选目录id，归蔽移动到自已的子目录下
	public function classTree($selCid){
		global $_G;
		if($selCid){
			$selCid = implode(',',$selCid);
			$arr = DB::fetch_all('select * from %t where uid=%d and cid not in (%i)', ['bphp_clouds_class',$_G['uid'],$selCid],'cid');
		}else{
			$arr = DB::fetch_all('select * from %t where uid=%d', ['bphp_clouds_class',$_G['uid']],'cid');
		}
		
		$arr = $this->setLevel($arr);
		
		
		//最大等级
		$maxLevel = 0;
		foreach($arr as $k=>$v){
			if($v['level']>$maxLevel){
				$maxLevel = $v['level'];
			}
		}
		
		//当只有一个等级时
		if($maxLevel == 0){return $arr;} 
		
		//子类归类
		for($i=$maxLevel;$i>0;$i--){
			foreach($arr as $key=>$val){
				if($val['level'] == $i){
					if(isset($arr[$val['pid']])){
						$arr[$val['pid']]['child'][] = $val;
					}
					unset($arr[$key]);
				}
			}
		}
		return $arr;
	}
	
	
	//设置目录等级
	public function setLevel($data,$pid=0,$level=0){
		static $arr=array();
        foreach($data as $k => $v) {
            if($v['pid']==$pid){
                $v['level']=$level;
                $arr[$k]=$v;
                $this->setLevel($data,$v['cid'],$level+1);
            }
        }
        return $arr;
	}
	
	
	
	
}