<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
include_once('bphp.func.php');

//七牛
require __DIR__ . '/vendor/qiniu/autoload.php';
use Qiniu\Auth;

//获取token
//$key 文件路径+名
function qiniuToken($key){
	global $_G;
	$pConfig = bphpConfig();
	
	//公钥、私钥、空间名
	$accessKey = $pConfig['qiniu']['accessKey'];
	$secretKey = $pConfig['qiniu']['secretKey'];
	$bucket = $pConfig['qiniu']['bucket'];
	
	//验证key
	$ext = '.'.strtolower(end(explode('.',$key)));
	$format = explode(',',$pConfig['format']);
	
	if(!in_array($ext,$format)){
		return ['sta'=>0,'msg'=>'文件格式不支持'];
	}
	//验证路径
	if(!preg_match('/^bphpClouds\/'.$_G['uid'].'\//',$key)){
		return ['sta'=>0,'msg'=>'文件路径不正确'];
	}
	

	// 初始化签权对象
	$auth = new Auth($accessKey, $secretKey);
	$upToken = $auth->uploadToken($bucket,$key, 3600,null, true);

	return ['sta'=>1,'msg'=>'success','data'=>$upToken];
}



//删除文件
//$path 文件路径
function qiniuDelFile($path){
	$pConfig = bphpConfig();
	
	//公钥、私钥、空间名
	$accessKey = $pConfig['qiniu']['accessKey'];
	$secretKey = $pConfig['qiniu']['secretKey'];
	$bucket = $pConfig['qiniu']['bucket'];
	
	$key = 'bphpClouds'.explode('bphpClouds',$path)[1];
	
	$auth = new Auth($accessKey, $secretKey);
	$config = new \Qiniu\Config();
	$bucketManager = new \Qiniu\Storage\BucketManager($auth, $config);
	$err = $bucketManager->delete($bucket, $key);
	if($err) {
		return ['sta'=>0,'msg'=>$err];
	}
	return ['sta'=>1,'msg'=>'success'];
}














    		  	  		  	  		     	  		      		   		     		       	  		      		   		     		       	  		 	    		   		     		       	  	       		   		     		       	  				    		   		     		       	  		 	    		   		     		       	  	       		 	      	  		  	  		     	
?>