const App = {
	data(){
		return {
			fileList:[],
			total:0, //总页数
			page:1,//当前页面
			uid:'',//用户id
			map:[],
		};
	},
	created(){
		 
	},
	methods:{
		//获取文件列表
		getFilelist(){
			request({
				ac:'fileList',
				page:this.page,
				uid:this.uid,
			},(res)=>{
				if(res.sta == 1){
					if(this.fileList.length == 0){
						this.total = res.total*1;
					}
					this.fileList = res.data;
					this.map = res.map;
				}
			},'','plugin.php?id=bphp_clouds:admin');
			return false;
		},
		
		//展示文件
		showFile(file){
			let video = ['avi','mp4','m4v','wmv','mpg','mpeg','mov','rm','ram','flv','swf'];
			if(video.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<video style="width:100%; max-height:100%;" src="'+file.path+'" controls="controls">您的浏览器不支持 video 标签。</video>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				return false;
			}
			let audio = ['mp3','wav','wma','mp2','flac','midi','ra','ape','aac','cda','mov'];
			if(audio.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<audio style="width:100%;" controls><source src="'+file.path+'" type="audio/mpeg"><source src="'+file.path+'" type="audio/ogg">您的浏览器不支持该音频格式</audio>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				
				return false;
			}
			
			let doc = ['pdf'];
			if(doc.includes(file.type)){
				let w = $(document).width();
				let h = $(document).height();
				window.open(file.path, '_blank', 'width='+w+',height='+h+'');
				return false;
			}
			ElementPlus.ElMessage({message:'该文件不支持预览',type: 'info'});
		},
		
		//下载
		downFile(fid){
			if(isWeChatBrowser()){
				ElementPlus.ElMessageBox.alert('微信浏览器不支持下载！请使用其它浏览器打开','提示',{
								type:'warning',
								autofocus:false,
								confirmButtonText: '知道了',
							}).catch(() => {});
				return false;
			}
			
			
			window.location.href='plugin.php?id=bphp_clouds:admin&url=download&fid='+fid;
		},
		
		//复制文件链接
		copyLink(str){
			copyText(str);
			ElementPlus.ElMessage({message:'文件链接已复制',type: 'success'});
		},
		
		//删除文件
		del(file){
			ElementPlus.ElMessageBox.confirm('您确定要删除已选中的文件吗? ','提示',{
			  confirmButtonText: '确定',
			  cancelButtonText: '取消',
			  type: 'warning',
			  autofocus:false,
			  dangerouslyUseHTMLString: true,
			}).then(() => {
				request({
					ac:'delFile',
					uid:file.uid,
					fid:file.id,
				},(res)=>{
					if(res.sta == 1){
						ElementPlus.ElMessage({message: res.msg,type: 'success'});
						this.getFilelist();
					}else{
						ElementPlus.ElMessage({message: res.msg,type: 'error'});
					}
				},'','plugin.php?id=bphp_clouds:admin');
			}).catch(() => {});

		},
		
		
		//选择页页
		selPage(p){
			this.page = p;
			this.getFilelist();
		}
	
	},
	mounted(){
		//用户uid
		if(getUrlParam('uid')){
			this.uid = getUrlParam('uid');
		}
		
		this.getFilelist();
		 
		 
	}

};

const app = Vue.createApp(App);
app.use(ElementPlus);
app.mount("#app");