const App = {
	data(){
		return {
			pUrl:'plugin.php?id=bphp_clouds:enjoy',
			enjoyList:[], //共享文件目录列表
			cid:0,//目录id
			pid:0,//上级目录id
			gid:0,//群组id
			type:'all',//文件类型
			fList:[],//文件列表
			cList:[],//目录列表
			page:0,//当前页数
			maxPage:1,//最大页数
			isLoadingMore:false,//正在加载更多中
			map:[],//当前位置
			uid:0,
			siteInfo:{},//网站信息
			listStyle:1,//列表风格
			listStyleDisplay:false,//列表风格下拉显隐
			searchKey:'',//搜索关键词
			platform:'pc',//平台
		}
	},
	created(){
		
		
	},
	methods:{
		//获取共享文件目录
		getEnjoyList(){
			if(this.maxPage <= this.page){
				return false;
			}
			
			if(this.isLoadingMore){
				return false;
			}
			
			this.isLoadingMore = true;
			this.page++;
			
			request({
				ac:'getEnjoyList',
				page:this.page,
				gid:this.gid,
			},(res)=>{
				if(res.sta == 1){
					this.enjoyList = this.enjoyList.concat(res.data.list);
					this.maxPage = res.data.maxPage;
					this.isLoadingMore = false;
				}
				if(res.sta == 0){
					ElementPlus.ElMessageBox.alert(res.msg,'提示',{
						confirmButtonText: '知道了',
						type:'warning',
						autofocus:false,
						callback:(action) => {
							window.location.href='plugin.php?id=bphp_clouds:enjoy';
						}
				    }).catch(() => {});
				}
				
			},'',this.pUrl);
		},
		
		//获取分类目录文件
		//文件列表显示
		fileDisplay(){
			//alert(this.maxPage);
			if(this.maxPage <= this.page){
				return false;
			}
			
			if(this.isLoadingMore){
				return false;
			}
			
			this.isLoadingMore = true;
			this.page++;
			
			request({
				ac:'fileDisplay',
				cid:this.cid,
				type:this.type,
				page:this.page,
				pid:this.pid,
				searchKey:this.searchKey
			},(res)=>{
				if(res.sta == 1){
					
					this.fList = this.fList.concat(res.fList);
					this.cList = this.cList.concat(res.cList);
					
					if(this.page == 1){
						this.map = res.map;
					}
					
					this.page = res.page;
					this.maxPage = res.maxPage;
				}
				if(res.sta == 0){
					ElementPlus.ElMessageBox.alert(res.msg,'提示',{
						confirmButtonText: '知道了',
						type:'warning',
						autofocus:false,
						callback:(action) => {
							window.location.href='plugin.php?id=bphp_clouds:enjoy';
						}
				    }).catch(() => {});
				}
				
				this.isLoadingMore = false;
			},'',this.pUrl);
			
			this.selFid = [];
			this.selCid = [];
		},
		
		
		//当前预览图片索引
		imgIndex(path){
			return this.showImglist.indexOf(path);
		},
		
		//下载
		downFile(file){
			
			if(isWeChatBrowser()){
				ElementPlus.ElMessageBox.alert('微信浏览器不支持下载！请使用其它浏览器打开','提示',{
								type:'warning',
								autofocus:false,
								confirmButtonText: '知道了',
							}).catch(() => {});
				return false;
			}
			
			//替换敏感字符
			let fName = file.name.replace(/\(/g,'（');
			fName = fName.replace(/\)/g,'）');
			
			window.location.href="plugin.php?id=bphp_clouds:show&url=d&link="+file.link+'&name='+fName;
			ElementPlus.ElMessage({message:'正在下载...',type: 'success'});
		},
		
		//复制文件链接
		copyLink(str){
			copyText(str);
			ElementPlus.ElMessage({message:'文件链接已复制',type: 'success'});
		},
		

		//展示文件
		showFile(file){

			let img = ['png','jpg','gif','jpeg','webp','svg'];
			if(img.includes(file.type)){
				vant.showImagePreview({
					images: this.showImglist,
					startPosition: this.showImglist.indexOf(file.link),
				});
				return false;
			}

			let video =['mp4','webm','ogg','ogv'];
			if(video.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<video style="width:100%; max-height:100%;" src="'+file.path+'" controls="controls">您的浏览器不支持 video 标签。</video>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				return false;
			}
			let audio = ['mp3','wav','wma','mp2','flac','midi','ra','ape','aac','cda','mov','3ga'];
			if(audio.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<audio style="width:100%;" controls><source src="'+file.path+'" type="audio/mpeg"><source src="'+file.path+'" type="audio/ogg">您的浏览器不支持该音频格式</audio>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				
				return false;
			}
			
			let doc = ['pdf'];
			if(doc.includes(file.type)){
				let w = $(document).width();
				let h = $(document).height();
				window.open(file.path, '_blank', 'width='+w+',height='+h+'');
				return false;
			}
			ElementPlus.ElMessage({message:'该文件不支持预览',type: 'info'});
		},


		
		
		//获取网站信息
		getSiteInfo(){
			request({
				ac:'siteInfo',
			},(res)=>{
				if(res.sta == 1){
					this.siteInfo = res.data;
				}else{
					alert('获取网站信息失败');
				}
			});
		},

		//修改列表样式
		setListStyle(val){
			this.listStyle = val;
			$.cookie('listStyle',val,{expires: 30});
			this.listStyleDisplay = false;
		},

		//文件大小文本
		sizeFormat(data){
			return sizeFormat(data);
		},
		//时间格式化
		timeFormat(time){
			return timeFormat(time);
		},

		//搜索
		search(){
			if(this.searchKey == ''){
				ElementPlus.ElMessage({message:'请输入关键词',type: 'error'});
				return false;
			}
			this.cList = [];
			this.fList = [];
			this.page = 0;
			this.maxPage = 1;
			this.fileDisplay();
		},
		//选择文件类型
		sleFile(type){
			this.type = type;
			this.cList = [];
			this.fList = [];
			this.page = 0;
			this.maxPage = 1;
			this.fileDisplay();
		}
	},
	
	mounted(){
		//站长查看其它用户组
		this.uid = BPHP.uid;
		if(BPHP.uid == 1){
			this.getSiteInfo();
		}
		
		
		
		if(getUrlParam('pid')){
			this.pid = getUrlParam('pid');
		}
		if(getUrlParam('gid')){
			this.gid = getUrlParam('gid');
		}else{
			this.gid = BPHP.gid;
		}
		
		
		if(getUrlParam('cid')){
			this.cid = getUrlParam('cid');
			this.fileDisplay();
		}else{
			this.getEnjoyList();
		}
		
		
		//监听是否滚动到底了
		listenIsBottom((res)=>{
			if(this.cid == 0){
				this.getEnjoyList();
			}else{
				this.fileDisplay();
			}
		},'#main');
		
		//列表样式
		if($.cookie('listStyle')){
			this.listStyle = $.cookie('listStyle');
		}else{
			this.listStyle  = this.config.listStyle;
		}
		
		if(isMobile()){
			this.platform = 'm';
		}
	
	},
	computed:{
		//预览图片列表
		showImglist(e){
			let imglist = [];
			this.fList.map((res)=>{
				if(['png','jpg','gif','jpeg','webp'].includes(res.type)){
					imglist.push(res.link);
				}
			});
			return imglist;
		},
		
	}

};

	
const app = Vue.createApp(App);
app.use(ElementPlus);
app.mount("#app");