const App = {
	data(){
		return {
			fList:[],//文件列表
			cList:[],//目录列表
			page:1,//当前页面
			maxPage:2,//最大页面
			key:'',
			isLoadingMore:false,//正在加载更多中
			repair:0,//最后一行补数
			okey:'',//起始key
			map:[],//当前位置
			
			//手机端
			fileConBox:false, //文件操作
			conFile:{}, //选中文件
			
			platform:'pc',//平台
			listStyle:1,//列表风格
			listStyleDisplay:false,//列表风格下拉显隐
		};
	},
	created(){
		//起始key
		if(!getUrlParam('okey')){
			this.okey = getUrlParam('key');
		}else{
			this.okey = getUrlParam('okey');
		}
	},
	methods:{
		//获取文件列表
		getFilelist(type='refresh'){
			if(type=='push'){
				this.page++;	
			}
			
			if(this.isLoadingMore == true){
				return false;
			}
			
			this.isLoadingMore = true;
			request({
				ac:'fileList',
				page:this.page,
				key:this.key,
				okey:this.okey,
			},(res)=>{
				if(res.sta == 1){
					//console.log(type);
					if(type=='refresh'){
						this.fList = res.fList;
						this.cList = res.cList;
						this.maxPage = res.maxPage;
						this.map = res.map;
					}
					
					if(type=='push'){
						this.fList = this.fList.concat(res.fList);
						this.cList = this.cList.concat(res.cList);
					}
					
					//补位，使最后一行对齐
					let w_w = $(document).width()-10;
					let rowNum = Math.trunc(w_w/117);
					let len = this.fList.length*1 + this.cList.length*1;
					this.repair = rowNum-(len%rowNum)+3;
					
					//没滚动条时，判断是否需要加载更多
					setTimeout(()=>{
						$("#fileArea").scrollTop(5); //控制滚动条下移 5px
						if( $("#fileArea").scrollTop() == 0 ){ //判断滚动条是否发生了偏移
							if(this.page<this.maxPage && this.isLoadingMore == false){
								this.getFilelist('push');
							}
						}
						$("#fileArea").scrollTop(0);//恢复滚动条返回顶部
					},500);
					
					
					
				}else{
					ElementPlus.ElMessageBox.alert(res.msg,'提示',{type:'error',autofocus:false}).catch(() => {});
				}
				
				this.isLoadingMore = false;
			},'','plugin.php?id=bphp_clouds:show');
			
			
			return false;
		},
		
		//展示文件
		showFile(file){
			let img = ['png','jpg','gif','jpeg','webp','svg'];
			if(img.includes(file.type)){
				vant.showImagePreview({
					images: this.showImglist,
					startPosition: this.showImglist.indexOf(file.link),
				});
				return false;
			}

			let video =['mp4','webm','ogg','ogv'];
			if(video.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<video style="width:100%; max-height:100%;" src="'+file.path+'" controls="controls">您的浏览器不支持 video 标签。</video>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				return false;
			}
			let audio = ['mp3','wav','wma','mp2','flac','midi','ra','ape','aac','cda','mov','3ga'];
			if(audio.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<audio style="width:100%;" controls><source src="'+file.path+'" type="audio/mpeg"><source src="'+file.path+'" type="audio/ogg">您的浏览器不支持该音频格式</audio>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				
				return false;
			}
			
			let doc = ['pdf'];
			if(doc.includes(file.type)){
				let w = $(document).width();
				let h = $(document).height();
				window.open(file.path, '_blank', 'width='+w+',height='+h+'');
				return false;
			}
			ElementPlus.ElMessage({message:'该文件不支持预览',type: 'info'});
		},
		
		//下载
		downFile(file){
			//替换敏感字符
			let fName = file.name.replace(/\(/g,'（');
			fName = fName.replace(/\)/g,'）');
			
			window.location.href="plugin.php?id=bphp_clouds:show&url=d&link="+file.link+'&name='+fName+'&size='+file.size;
			ElementPlus.ElMessage({message:'正在下载...',type: 'success'});
		},
		
		//复制文件链接
		copyLink(str){
			copyText(str);
			ElementPlus.ElMessage({message:'文件链接已复制',type: 'success'});
		},
		
		//文件大小文本
		sizeFormat(data){
			return sizeFormat(data);
		},
		
		//手机端下载
		mDownFile(file){
			this.conFile = file;
			this.fileConBox = true;
		},
	
		//当前预览图片索引
		imgIndex(path){
			return this.showImglist.indexOf(path);
		},

		//修改列表样式
		setListStyle(val){
			this.listStyle = val;
			$.cookie('listStyle',val,{expires: 30});
			this.listStyleDisplay = false;
		}
	},
	mounted(){
		//用户uid
		if(getUrlParam('key')){
			this.key = getUrlParam('key');
		}
		
		this.getFilelist();
		 
		//监听是否滚动到底了
		listenIsBottom((res)=>{
			if(this.page<this.maxPage && this.isLoadingMore == false){
				this.getFilelist('push');
			}
		},'#fileArea');

		
		if(isMobile()){
			this.platform = 'm';
		}
		

		//列表样式
		if($.cookie('listStyle')){
			this.listStyle = $.cookie('listStyle');
		}else{
			this.listStyle  = this.config.listStyle;
		}
	},
	computed:{
		//预览图片列表
		showImglist(e){
			let imglist = [];
			this.fList.map((res)=>{
				if(['png','jpg','gif','jpeg','webp'].includes(res.type)){
					imglist.push(res.link);
				}
			});
			return imglist;
		},
	}
};

const app = Vue.createApp(App);
app.use(ElementPlus);
app.mount("#app");