const App = {
	data(){
		return {
			config:'',//插件配置
			pUrl:'plugin.php?id=bphp_clouds:enjoyList',
			enjoyList:[], //共享文件目录列表
			cid:0,//目录id
			pid:0,//上级目录id
			gid:0,//群组id
			page:0,//当前页数
			maxPage:1,//最大页数
			isLoadingMore:false,//正在加载更多中
			uid:0,
			siteInfo:{},//网站信息
			listStyle:1,//列表风格
			searchKey:'',//搜索关键词
			count:'',//数据总条数
			banner:[],//轮播图
		}
	},
	created(){
		
		
	},
	methods:{
		//获取插件配置
		getConfig(){
			return new Promise(resolve => {
				request({
					ac:'config',
				},(res)=>{
					if(res.sta == 0){
						if(res.err == 'nologin'){
							ElementPlus.ElMessageBox.alert(res.msg,'提示',{
								confirmButtonText: '前往登陆',
								type:'warning',
								autofocus:false,
								callback:(action) => {
									window.location.href='member.php?mod=logging&action=login&referer='+window.location.href;
								}
							}).catch(() => {});
							
						}else{
							ElementPlus.ElMessage({type: 'warning',message: res.msg});	
						}
					}else{
						resolve(res.data);
					}
				});
			});
		},
		//获取共享文件目录
		getEnjoyList(){
			if(this.maxPage <= this.page){
				return false;
			}
			
			if(this.isLoadingMore){
				return false;
			}
			
			this.isLoadingMore = true;
			this.page++;
			
			request({
				ac:'getEnjoyList',
				page:this.page,
				gid:this.gid,
				searchKey:this.searchKey
			},(res)=>{
				if(res.sta == 1){
					this.enjoyList = this.enjoyList.concat(res.data.list);
					this.maxPage = res.data.maxPage;
					this.page = res.data.page;
					this.count = res.data.count;
					this.isLoadingMore = false;
					
				}
				if(res.sta == 0){
					ElementPlus.ElMessageBox.alert(res.msg,'提示',{
						confirmButtonText: '知道了',
						type:'warning',
						autofocus:false,
						callback:(action) => {
							window.location.href='plugin.php?id=bphp_clouds:enjoyList';
						}
				    }).catch(() => {});
				}
				
			},'',this.pUrl);
		},
		
		
		
		//获取网站信息
		getSiteInfo(){
			request({
				ac:'siteInfo',
			},(res)=>{
				if(res.sta == 1){
					this.siteInfo = res.data;
				}else{
					alert('获取网站信息失败');
				}
			});
		},

		//修改列表样式
		setListStyle(val){
			this.listStyle = val;
			$.cookie('listStyle',val,{expires: 30});
			this.listStyleDisplay = false;
		},


		//搜索
		search(){
			if(this.$refs.searchKey.value == ''){
				alert('请输入关键词');
				return false;
			}
			this.searchKey = this.$refs.searchKey.value;
			this.enjoyList = [];
			this.page = 0;
			this.maxPage = 1;
			this.getEnjoyList();
		},
		//取消搜索
		cancleSearch(){
			this.$refs.searchKey.value = '';
			this.searchKey = '';
			this.enjoyList = [];
			this.page = 0;
			this.maxPage = 1;
			this.getEnjoyList();
		},
		//提取轮播图数据
		getBanner(){
			if(!this.config.gxBanner){
				return false;
			}
			if(this.config.gxBanner == ''){
				return false;
			}
			let banner = this.config.gxBanner;
			banner = banner.split("\n");
			banner.map((item,index)=>{
				banner[index] = item.split('|');
			});
			this.banner = banner;
		}
	},
	
	async mounted(){
		//站长查看其它用户组
		this.uid = BPHP.uid;
		
		if(getUrlParam('pid')){
			this.pid = getUrlParam('pid');
		}
		if(getUrlParam('gid')){
			this.gid = getUrlParam('gid');
		}else{
			this.gid = BPHP.gid;
		}
		
		//获取插件配置
		this.config = await this.getConfig();
		
		this.getBanner();
		
		if(getUrlParam('cid')){
			this.cid = getUrlParam('cid');
			this.fileDisplay();
		}else{
			this.getEnjoyList();
		}


		
		
		//监听是否滚动到底了
		listenIsBottom((res)=>{
			if(this.page>=this.maxPage){
				return false;
			}

			if(this.cid == 0){
				this.getEnjoyList();
			}else{
				this.fileDisplay();
			}
		},'#main');
		
		//列表样式
		if($.cookie('listStyle')){
			this.listStyle = $.cookie('listStyle');
		}else{
			this.listStyle  = this.config.listStyle;
		}
		
		//回车搜索
		document.getElementById('searchInput').addEventListener('keydown', (event)=>{  
			if (event.keyCode === 13) { // 13 是回车键的键码  
				event.preventDefault(); // 阻止默认行为，例如提交表单  
				this.search();
			}  
		});  
	},
	computed:{
		
	}

};

	
const app = Vue.createApp(App);
app.use(ElementPlus);
app.use(vant);
app.mount("#app");