const App = {
	data() {
		return {
			config:'',//插件配置
			userInfo:{},//用户信息
			siteInfo:{},//网站信息
			fileList:[],//文件上传列表
			listStyle:1,//列表风格
			showUpDialog:false, //显示上传对话框
			isAddEvent:false,//是否已添加拖动与粘帖文件上传事件
			fileTips:'', //上传文件提示
			uping:false, //上传中
			stopUp:false,//取消上传
			upCheck:false,//文件上传是否已验证
			selFid:[],//选的文件id
			selCid:[],//选的目录id
			cid:0,//目录id
			pid:0,//上级目录id
			type:'all',//文件类型
			fList:[],//文件列表
			cList:[],//目录列表
			page:1,//当前页数
			maxPage:1,//最大页数
			count:0,//列表总条数
			isLoadingMore:false,//正在加载更多中
			map:[],//当前位置
			showAddClass:false, //显示添加分类
			addClassName:'', //添加分类名
			
			moveDialog:false,//移动文件对话框
			classTree:[],//目录树
			classList:[],//分类列表
			activeClass:[],//当前选中分类
			classMap:[],//分类位置
			searchKey:'',//搜索关键词
			
			//添加快链接
			addLinkForm:{
				dialog:false,
				name: '',
				href:'',
				target:false,
				rules:{
					name: [
						{ required: true, message: '请输入链接名称', trigger: 'blur' },
					],
					href: [
						{ required: true, message: '请输入链接地址', trigger: 'blur' },
						{ validator: checkLink, trigger: 'blur' },
					],
				}
			},
			
			//分享
			shareForm:{
				file:{},
				dialog:false,
				outTime:0,
				pass:randomCode(6),
				type:'1', //1提取码下载，2积分下载
				havePass:'1', //是否有密码
				integral:0, //积分
				integralType:1, //积分类型 
				freeGroupId:0, //免费下载用户组
				rules:{
					pass:[
						{required: true, message: '请输入提取码', trigger: 'blur' },
						{validator: checkPass, trigger: 'blur'},
					],
					integral:[
						{required: true, message: '请输入一个正整数', trigger: 'blur' },
						{validator: checkInt, trigger: 'blur'},
					],
				}
			},
			
			client:{}, //oss对象
			
			//设置共享
			enjoyForm:{
				dialog:false,
				groupIds:[],
				file:{},
				rules:{
					groupIds:[
						{required: true, message: '至少选择一个用户组', trigger: 'blur' },
					],
				},
				outTime:30,
				enjoyInfo:{},
			},
			showEnjoy:false, //展示共享文件
			
			//手机端参数------------------------------------
			types:[ //文件类型
			  { text: '全部',index:'all'},
			  { text: '图片',index:'img'},
			  { text: '文档',index:'doc' },
			  { text: '视频',index:'vid' },
			  { text: '音频',index:'aud' },
			],
			addBox:false, //上传、新建文件夹
			fileConBox:false, //文件操作
			conFile:{}, //当前操作文件
			classConBox:false, //文件夹操作
			conClass:{},//当前操作文件夹
			selCon:false,//顶部显示选择控制
			isWeixin:false, //是否为微信浏览器
			fastLinkDialog:false, //快捷链接弹窗

			fileInfo:{ //文件属性
				file:{},
				dialog:false
			},
			

		};
	},
	created(){
		
	},
	methods:{
		
		//m选择文件类型
		sleType(e){
			window.location.href= 'plugin.php?id=bphp_clouds:index&type='+e.index;
		},
		
		//获取插件配置
		getConfig(){
			return new Promise(resolve => {
				request({
					ac:'config',
				},(res)=>{
					if(res.sta == 0){
						if(res.err == 'nologin'){
							ElementPlus.ElMessageBox.alert(res.msg,'提示',{
								confirmButtonText: '前往登陆',
								type:'warning',
								autofocus:false,
								callback:(action) => {
									window.location.href='member.php?mod=logging&action=login&referer='+window.location.href;
								}
							}).catch(() => {});
							
						}else{
							ElementPlus.ElMessage({type: 'warning',message: res.msg});	
						}
					}else{
						resolve(res.data);
					}
				});
			});
		},
		
		//获取用户信息
		//refresh 是否刷新
		getUserInfo(refresh = false){
			if(!refresh){
				if($.cookie('bphp_userInfo')){
					this.userInfo = JSON.parse($.cookie('bphp_userInfo'));
					return 1;
				}
			}
			return new Promise(resolve => {
				request({
					ac:'getUserInfo',
				},(res)=>{
					if(res.sta == 1){
						$.cookie('bphp_userInfo',JSON.stringify(res.data));
						this.userInfo = res.data;
					}
					
					if(res.sta == 0){
						ElementPlus.ElMessageBox.alert(res.msg,'提示',{
							confirmButtonText: '前往登陆',
							type:'warning',
							autofocus:false,
							callback:(action) => {
								window.location.href='member.php?mod=logging&action=login&referer='+window.location.href;
							}
						}).catch(() => {});
					}
					
					if(res.sta == 2){
						ElementPlus.ElMessageBox.confirm('<div style="text-align:left;">'+this.config.agreement+'</div>','云盘使用协议',{
							confirmButtonText: '同意并开通',
							cancelButtonText: '不同意',
							type: 'success',
							center: true,
							autofocus:false,
							showClose:false,
							closeOnClickModal:false,
							dangerouslyUseHTMLString:true,
						}).then(() => {
							request({
								ac:'buildUser',
							},(res)=>{
								if(res.sta == 0){
									ElementPlus.ElMessageBox.alert(res.msg,'提示',{
										confirmButtonText: '退出',
										type:'warning',
										autofocus:false,
										callback:(action) => {
											window.location.href= BPHP.siteurl;
										}
									}).catch(() => {});
								}
								if(res.sta == 1){
									ElementPlus.ElMessage({type: 'success',message: res.msg})
									location.reload();
								}
							});
						}).catch(() => { 
							ElementPlus.ElMessage({type: 'warning',message: '正在退出...',onClose:function(){
								window.location.href = BPHP.siteurl;
							}})
						});
					}
					resolve(res.sta);
				});
			});
		},
		
		//获取网站信息
		getSiteInfo(){
			request({
				ac:'siteInfo',
			},(res)=>{
				if(res.sta == 1){
					this.siteInfo = res.data;
				}else{
					alert('获取网站信息失败');
				}
			});
		},
		
		//刷新空间容量
		refCap(depth = 0){
			request({
				ac:'refCap',
				depth:depth
			},(res)=>{
				if(res.sta == 1){
					this.userInfo.capacity = res.capacity;
					this.userInfo.spaceSize = res.spaceSize;
					$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
					if(depth == 1){
						ElementPlus.ElMessage({type: 'success',message: res.msg});
					}
				}else{
					ElementPlus.ElMessage({type: 'warning',message: res.msg});
				}
			});
		},

		//点击上传
		upfile(){
			this.selFile();
			this.fileList = [];
			this.addBox = false;
		},
		//选择上传文件
		selFile(){
			$('#upPicker').val('').click();
		},
		
		//获取选择文件
		addFile(e){
			if(!this.showUpDialog){
				this.showUpDialog = true;
			}
			let files = e.target.files || e.dataTransfer.files;
			this.addFileFn(files);
		},
		
	
		//添加文件方法
		addFileFn(files){
			if(!Array.isArray(files)){
				files=Array.from(files);
			}
			files.map((file,index)=>{
				//验证重复名称不添加
				let isAdd = true;
				this.fileList.map((res)=>{
					if(file.name == res.name){
						ElementPlus.ElMessage({message: file.name+' 文件名重复！',type: 'warning'})
						isAdd = false;
					}
				});
				
				//验证文件格式
				let ext = file.name.substring(file.name.lastIndexOf(".")).toLowerCase();
				if(this.config.format.indexOf(ext) == -1){
					ElementPlus.ElMessage({message: ext+' 文格式不支持',type: 'warning'})
					isAdd = false;
				}
				
				//验证空间大小
				if(this.userInfo.capacity*1+file.size*1>this.userInfo.spaceSize*1){
					ElementPlus.ElMessage({message:' 剩于空间不足！',type: 'warning'})
					isAdd = false;
				}
				
				let item = {};
				item.name = file.name;
				item.size = file.size;
				item.sizeText = sizeFormat(file.size);
				item.sta = 'wait';
				item.msg = '等待上传';
				item.source = file;
				item.check = false; //验证
				item.rePath = ''; //替换存储文件路径
				if(isAdd){
					this.fileList.push(item);
				}
			});
			this.fileTips = '已选择了 '+this.fileList.length+' 个文件';
		},
			
		//打开上传对话框
		openFileDialog(){
			
		},
		
		//关闭上传对话框
		closeFileDialog(){},

		//开始上传
		async upStart(cehck = false){
			if(this.fileList.length == 0){
				this.upCheck = false;
				ElementPlus.ElMessage.error('请选择上传文件！');
				return false;
			}
			
			if(cehck == false){
				//验证文件名是否重复
				let res = await this.beforeUpCheck();
				if(res.sta == 0 && this.upCheck == false){
					this.userConfirm(res.waitCheckFile);
					return false;
				}
			}
			
			this.fileTips = '正在上传（0/'+this.fileList.length+'）';
			
			if(this.config.storageType == 'local'){
				this.localSendFile(0);
			}
			
			if(this.config.storageType == 'aliyun'){
				this.aliyunSendFile(0);
			}
			
			if(this.config.storageType == 'qiniu'){
				this.qiniuSendFile(0);
			}
			
			if(this.config.storageType == 'ftp'){
				this.localSendFile(0);
			}
			
		},
		
		//文件上传前验证
		beforeUpCheck(){
			let checkFile = [];
			this.fileList.map((res,index)=>{
				checkFile.push({name:res.name});
			});
			
			return new Promise(resolve => {
				request({
					ac:'checkFileName',
					checkFile:checkFile,
					cid:this.cid
				},(res)=>{
					resolve(res);
				});
				
			});
		},
		
		//用户确认，文件名重复操作
		userConfirm(waitCheckFile,i=0){
			if(i>=waitCheckFile.length){
				this.upCheck = true;
				this.upStart(true);
				return false;
			}
			
			let file = waitCheckFile[i];
			ElementPlus.ElMessageBox.confirm('检测到有同命名文件【'+file.name+'】，是否覆盖？'+'<div class="reNameCehck"><input type="checkbox" class="checkAll" /> <span>为之后文件冲突执行此操作</span></div>','提示',{
				  confirmButtonText: '确认',
				  cancelButtonText: '跳过',
				  type: 'warning',
				  showClose:false,
				  dangerouslyUseHTMLString: true,
				  autofocus:false,
			}).then(() => {
				let checkAll = $('.checkAll').get(0).checked;
				if(checkAll){
					waitCheckFile.map(file=>{
						this.fileList.map((res)=>{
							if(res.name == file.name){
								res.rePath = file.path;
							}
						});
					});
					this.upCheck = true;
					this.upStart(true);
				 }else{
					 this.fileList.map((res)=>{
						 if(res.name == file.name){
							res.rePath = file.path;
						 }
					 });
					this.userConfirm(waitCheckFile,i*1+1);
				}
			}).catch(() => {
				let checkAll = $('.checkAll').get(0).checked;
				if(checkAll){
					waitCheckFile.map(file=>{
						this.fileList.map((res)=>{
							if(res.name == file.name){
								this.fileList.splice(file.index, 1);
							}
						});
					});
					this.upCheck = true;
					this.upStart(true);
				}else{
					this.fileList.map((res,index)=>{
						if(res.name == file.name){
							this.fileList.splice(file.index, 1);
						}
				   });
				   this.userConfirm(waitCheckFile,i*1+1);
				}
			})
		},
		
		
		//本地文件上传，进度提示
		localSendFile(index,errorFile=0){
			this.uping = true;
			let fileList = this.fileList;
			
			//本地上传
			localUpfile(fileList[index],'plugin.php?id=bphp_clouds:api',this.cid,(res)=>{
				fileList[index].msg = res.msg;
				fileList[index].sta = res.sta;
				fileList[index].progress = res.progress;
				
				//禁止上传
				if(this.stopUp == true){
					return false;
				}
				let eTime =  Date.parse(new Date())+1;
	
				//速度提示
				if(res.speed){
					this.fileTips = '正在上传（'+index+'/'+fileList.length+'），上传速度 '+res.speed+'/s';
				}

				//循环
				if(res.sta == 'failed'){
					errorFile++;
				}
				if(res.sta == 'success' || res.sta == 'failed'){
					if(index < fileList.length-1){
						//滚动条下滑
						if(index>4){
							divScrollTo('.f-list',40);
						}
						this.localSendFile(index+1,errorFile);
					}else{
						if(errorFile>0){
							ElementPlus.ElMessage({message: '有 '+errorFile+' 个文件上传失败！',type: 'warning'});
						}else{
							ElementPlus.ElMessage.success('上传完成！');
						}
						if(errorFile == 0){
							this.showUpDialog = false;
						}
						this.upCheck = false;
						this.uping = false;
						this.fileDisplay();
						if(res.sta == 'success'){
							this.userInfo.capacity = res.capacity;
							$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
						}
					}
				}
			});
		},

		
		//阿里云文件上传，进度提示
		aliyunSendFile(index,errorFile=0){
			this.uping = true;
			let fileList = this.fileList;

			//阿里云上传
			aliyunUpfile(fileList[index],'plugin.php?id=bphp_clouds:api',this.cid,(res)=>{
				fileList[index].msg = res.msg;
				fileList[index].sta = res.sta;
				fileList[index].progress = res.progress;

				//禁止上传
				if(this.stopUp == true){
					return false;
				}
				let eTime =  Date.parse(new Date())+1;
				
				//速度提示
				if(res.speed){
					this.fileTips = '正在上传（'+index+'/'+fileList.length+'），上传速度 '+res.speed+'/s';
				}
				
				//循环
				if(res.sta == 'failed'){
					errorFile++;
				}
				if(res.sta == 'success' || res.sta == 'failed'){
					if(index < fileList.length-1){
						//滚动条下滑
						if(index>4){
							divScrollTo('.f-list',40);
						}

						this.aliyunSendFile(index+1,errorFile);
					}else{
						if(errorFile>0){
							ElementPlus.ElMessage({message: '有 '+errorFile+' 个文件上传失败！',type: 'warning'});
						}else{
							ElementPlus.ElMessage.success('所有文件已上传完成！');
						}
						
						if(errorFile == 0){
							this.showUpDialog = false;
						}
						this.upCheck = false;
						this.uping = false;
						this.fileDisplay();
						if(res.sta == 'success'){
							this.userInfo.capacity = res.capacity;
							$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
						}
						
					}
				}
			},this.client);
		},
		
		//七云文件上传，进度提示
		qiniuSendFile(index,errorFile=0){
			this.uping = true;
			let fileList = this.fileList;

			//阿里云上传
			qiniuUpfile(fileList[index],'plugin.php?id=bphp_clouds:api',this.cid,(res)=>{
				fileList[index].msg = res.msg;
				fileList[index].sta = res.sta;
				fileList[index].progress = res.progress;

				//禁止上传
				if(this.stopUp == true){
					return false;
				}
				let eTime =  Date.parse(new Date())+1;
				
				//速度提示
				if(res.speed){
					this.fileTips = '正在上传（'+index+'/'+fileList.length+'），上传速度 '+res.speed+'/s';
				}
				
				//循环
				if(res.sta == 'failed'){
					errorFile++;
				}
				if(res.sta == 'success' || res.sta == 'failed'){
					if(index < fileList.length-1){
						//滚动条下滑
						if(index>4){
							divScrollTo('.f-list',40);
						}

						this.qiniuSendFile(index+1,errorFile);
					}else{
						if(errorFile>0){
							ElementPlus.ElMessage({message: '有 '+errorFile+' 个文件上传失败！',type: 'warning'});
						}else{
							ElementPlus.ElMessage.success('所有文件已上传完成！');
						}
						
						if(errorFile == 0){
							this.showUpDialog = false;
						}
						this.upCheck = false;
						this.uping = false;
						this.fileDisplay();
						if(res.sta == 'success'){
							this.userInfo.capacity = res.capacity;
							$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
						}
						
					}
				}
			});
		},
	
		//取消上传
		upCancel(){
			this.uping = false;
			this.stopUp = true;
			this.showUpDialog = false;
			this.fileDisplay();
		},
		
		//文件列表显示
		//ac 方法，push 添加，reload  重载
		fileDisplay(ac='reload'){
			if(ac=='reload'){
				this.page = 1;
			}
			//判断是否正在加载中，避免重复请求
			if(this.isLoadingMore){
				return false;
			}
			this.isLoadingMore = true;
			
			request({
				ac:'fileDisplay',
				cid:this.cid,
				type:this.type,
				page:this.page,
				searchKey:this.searchKey
			},(res)=>{
				if(res.sta == 1){
					if(ac=='reload'){
						this.fList = res.fList;
						this.cList = res.cList;
					}
					
					if(ac=='push'){
						this.fList = this.fList.concat(res.fList);
						this.cList = this.cList.concat(res.cList);
					}

					this.map = res.map;
					this.pid = res.pid;
					this.page = res.page;
					this.count = res.count;
					this.maxPage = res.maxPage;
				}
				if(res.sta == 0){
					ElementPlus.ElMessageBox.alert(res.msg,'提示',{
						confirmButtonText: '前往登陆',
						type:'warning',
						autofocus:false,
						callback:(action) => {
							window.location.href='member.php?mod=logging&action=login&referer='+window.location.href;
						}
				    }).catch(() => {});
				}
				
				this.isLoadingMore = false;
			});
			
			this.selFid = [];
			this.selCid = [];
		},
		
		//点击选择文件
		selChange(fid,type){
			if(type == 'file'){
				let index = this.selFid.indexOf(fid);
				if (index > -1) {
					this.selFid.splice(index, 1);
				}else{
					this.selFid.push(fid);
				}
			}
			if(type == 'classify'){
				let index = this.selCid.indexOf(fid);
				if (index > -1) {
					this.selCid.splice(index, 1);
				}else{
					this.selCid.push(fid);
				}
			}
		},
		//全选
		selAll(){
			if(this.selFid.length + this.selCid.length == this.fList.length + this.cList.length){
				this.selFid = [];
				this.selCid = [];
			}else{
				let selFid = [];
				let selCid = [];
				this.fList.map((file)=>{
					selFid.push(file.id);
				});
				this.cList.map((classify)=>{
					selCid.push(classify.cid);
				});
				
				this.selFid = selFid;
				this.selCid = selCid;
			}
		},
		//添加目录
		addClass(){
			if(this.addClassName == ''){
				ElementPlus.ElMessage({
					message: '文件夹名称不能为空',
					type: 'warning',
				});
				return false;
			}

			request({
				ac:'addClassName',
				addClassName:this.addClassName,
				cid:this.cid,
			},(res)=>{
				if(res.sta == 1){
					ElementPlus.ElMessage({message: res.msg,type: 'success'});
					this.showAddClass = false;
					this.addClassName = '';
					this.fileDisplay();
				}else{
					ElementPlus.ElMessage({message: res.msg,type: 'warning'});
				}
			});
		},
		focusAddClass(){
			$('.layout-main').scrollTop(0);
			setTimeout(function(){
				$('.className .el-input__inner').focus();
			},100);
		},
		//展示文件
		showFile(file){
			if(this.selCon){
				return false;
			}
			let img = ['png','jpg','gif','jpeg','webp','svg'];
			if(img.includes(file.type)){
				vant.showImagePreview({
					images: this.showImglist,
					startPosition: this.showImglist.indexOf(file.link),
				});
				return false;
			}
			
			let video =['mp4','webm','ogg','ogv'];
			if(video.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<video style="width:100%; max-height:100%;" src="'+file.link+'" controls="controls">您的浏览器不支持 video 标签。</video>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				return false;
			}
			let audio = ['mp3','wav','wma','mp2','flac','midi','ra','ape','aac','cda','mov','3ga'];
			if(audio.includes(file.type)){
				ElementPlus.ElMessageBox.alert('<audio style="width:100%;" controls><source src="'+file.link+'" type="audio/mpeg"><source src="'+file.link+'" type="audio/ogg">您的浏览器不支持该音频格式</audio>', file.name, {
					dangerouslyUseHTMLString: true,
					autofocus:true,
					draggable:true,
					showConfirmButton:false,
				}).catch(() => {});
				
				return false;
			}
			
			let doc = ['pdf'];
			if(doc.includes(file.type)){
				let w = $(document).width();
				let h = $(document).height();
				window.open(file.link, '_blank', 'width='+w+',height='+h+'');
				return false;
			}
			ElementPlus.ElMessage({message:'该文件不支持预览',type: 'info'});
		},
		
		//删除文件
		del(obj=''){
			if(obj != ''){
				if(obj.hasOwnProperty('c_name')){
					this.selCid = [obj.cid];
				}else{
					this.selFid = [obj.id];
				}
			}
			
			ElementPlus.ElMessageBox.confirm('您确定要删除已选中的文件吗? ','提示',{
			  confirmButtonText: '确定',
			  cancelButtonText: '取消',
			  type: 'warning',
			  autofocus:false,
			  dangerouslyUseHTMLString: true,
			}).then(() => {
				this.selCon=false;
				request({
					ac:'del',
					cid:this.selCid,
					fid:this.selFid,
				},(res)=>{
					if(res.sta == 1){
						ElementPlus.ElMessage({message: res.msg,type: 'success'});
						this.fileDisplay();
						this.userInfo.capacity = res.capacity;
						$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
					}else{
						ElementPlus.ElMessage({message: res.msg,type: 'error'});
					}
				});
				
				this.selFid = [];
				this.selCid = [];
				
			}).catch(() => {
				this.selCon=false;
				this.selFid = [];
				this.selCid = [];
			});

		},
		
		//复制文件链接
		copyLink(str){
			copyText(str);
			ElementPlus.ElMessage({message:'文件链接已复制',type: 'success'});
		},
		
		//重命名
		reName(obj){
			if(obj.hasOwnProperty('c_name')){
				var type = 'classfiy';
				var sid =obj.cid;
				var pid =obj.pid;
				var name =obj.c_name;
			}else{
				var type = 'file';
				var sid =obj.id;
				var pid =obj.cid;
				var name =obj.name;
			}
			ElementPlus.ElMessageBox.prompt('', '重命名', {
				confirmButtonText: '确认',
				cancelButtonText: '取消',
				inputPattern:/[\s\S]+/,
				inputErrorMessage: '请输入文件名',
				inputPlaceholder:'请输入...',
				inputValue:name
			}).then(({ value }) => {
				if(value == name){
					ElementPlus.ElMessage({message: '您未做任何修改！',type: 'error'});
					return false;
				}
				request({
					ac:'reName',
					name:value,
					sid:sid,
					pid:pid,
					type:type,
				},(res)=>{
					if(res.sta == 1){
						ElementPlus.ElMessage({
							type: 'success',
							message: res.msg,
						});
						if(type == 'classfiy'){
							obj.c_name = value;
						}else{
							obj.name = value;
						}
					}else{
						ElementPlus.ElMessage({message: res.msg,type: 'error'});
					}
				});
			}).catch(() => {});
		},
		
		
		//移动 start-----------------------------------------------------------------------
		move(obj = ''){
			if(obj != ''){
				if(obj.hasOwnProperty('c_name')){
					this.selCid = [obj.cid];
				}else{
					this.selFid = [obj.id];
				}
			}
			
			//目录树
			request({
				ac:'classTree',
				selCid:this.selCid
			},(res)=>{
				if(res.sta == 1){
					this.moveDialog = true;
					this.classTree = res.data;
					this.classList =  res.data;
					this.classMap = [{cid:0,c_name:'全部文件',child:res.data}];
					this.activeClass = {cid:0,c_name:'全部文件',child:res.data};
				}
				
				
			});
		},
		
		//选择目录
		selClass(classify){
			if(classify.child){
				this.classList =  classify.child;
			}else{
				this.classList =  [];
			}
			
			this.activeClass =  classify;
			this.classMap.push(classify);
		},
		
		//点击目录地图
		selMap(c){
			this.classList = c.child;
			let newMap = [];
			for(var i = 0; i < this.classMap.length; i++) {
				newMap.push(this.classMap[i]);
			　　if(this.classMap[i].cid == c.cid) {
			　　　　 break;
			　　}
			}
			this.classMap = newMap;
		},
		//目录地图返回上一级
		goback(){
			let newMap = [];
			for(var i = 0; i < this.classMap.length-1; i++) {
			　　newMap.push(this.classMap[i]);
				this.classList = this.classMap[i].child;
			}
			this.classMap = newMap;
		},
		
		//移动到
		moveTo(){
			let moveCid = this.classMap[(this.classMap.length-1)].cid;
			request({
				ac:'move',
				selFid:this.selFid,//选的文件id
				selCid:this.selCid,//选的目录id
				moveCid:moveCid //移到些目录id
			},(res)=>{
				this.moveDialog = false;
				this.fileDisplay();
				if(res.sta == 1){
					ElementPlus.ElMessage({type: 'success',message: res.msg,});
				}
				
				if(res.sta == 0){
					ElementPlus.ElMessage({type: 'warning',message: res.msg,});
				}
				this.selCon = false;
			});
		},
		
		//移动 end-----------------------------------------------------------------------
		
		//加载更多
		loadMore(){
			if(this.page<this.maxPage && this.isLoadingMore == false){
				this.page++;
				this.fileDisplay('push');
			}
		},
		
		//下载
		downFile(fid){
			if(isWeChatBrowser()){
				ElementPlus.ElMessageBox.alert('微信浏览器不支持下载！请使用其它浏览器打开','提示',{
								type:'warning',
								autofocus:false,
								confirmButtonText: '知道了',
							}).catch(() => {});
				return false;
			}
			window.location.href=this.siteInfo.siteurl+'plugin.php?id=bphp_clouds:index&url=download&fid='+fid;
		},
		
		//远程下载文件
		//replace 1替换
		downRemote(){
			ElementPlus.ElMessageBox.prompt('请输入远程文件地址，大文件不支持哦~', '远程文件下载', {
				confirmButtonText: '确认',
				cancelButtonText: '取消',
				inputPattern:/[\s\S]+/,
				inputErrorMessage: '请输入远程文件地址',
				inputPlaceholder:'请输入...',
			}).then(({ value }) => {
				request({
					ac:'downRemote',
					cid:this.cid,
					remoteUrl:value,
					replace:0
				},(res)=>{
					if(res.sta == 1){
						ElementPlus.ElMessage({type: 'success',message: res.msg,});
						this.fileDisplay();
					}else if(res.sta == 2){
						ElementPlus.ElMessageBox.confirm(res.msg,'提示',{
							confirmButtonText: '替换',
							cancelButtonText: '取消',
							type: 'warning',
							autofocus:false,
						  }).then(() => {
							  request({
									ac:'downRemote',
									cid:this.cid,
									remoteUrl:value,
									replace:1
								},(res)=>{
									if(res.sta == 1){
										ElementPlus.ElMessage({type: 'success',message: res.msg,});
										this.fileDisplay();
									}else{
										ElementPlus.ElMessage({message: res.msg,type: 'error'});
									}
								});
								
								this.addBox = false;
						}).catch(() => {})
					}else{
						ElementPlus.ElMessage({message: res.msg,type: 'error'});
					}
				});
			}).catch(() => {
				this.addBox = false;
			})
			
		},
		
		//搜索
		search(){
			if(this.$refs.searchKey.value == ''){
				alert('请输入关键词');
				return false;
			}
			this.searchKey = this.$refs.searchKey.value;
			this.fileDisplay();
		},
		
		//设置快捷链接
		setLink(){
			//表单验证
			let formEl = this.$refs.linkForm;
			formEl.validate((valid) => {
				if(valid){
					request({
						ac:'setLink',
						type:this.addLinkForm.type,
						index:this.addLinkForm.index,
						name:this.addLinkForm.name,
						href:this.addLinkForm.href,
						target:this.addLinkForm.target,
					},(res)=>{
						this.addLinkForm.dialog = false;
						if(res.sta == 1){
							this.addLinkForm.name = '';
							this.addLinkForm.href = '';
							this.addLinkForm.target = false;
							this.userInfo.fastLink =res.data;
							$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
							ElementPlus.ElMessage({type: 'success',message: res.msg,});
						}else{
							ElementPlus.ElMessage({type: 'warning',message: res.msg,});
						}
					});
				}else {
					console.log('error submit!')
				}
			});
		},
		
		//编辑/添加快捷链接
		fastLink(type,item='',index=''){
			this.addLinkForm.dialog = true;
			this.addLinkForm.type = type;
			this.addLinkForm.index = index;
			this.addLinkForm.name = item.name;
			this.addLinkForm.href = item.href;
			this.addLinkForm.target = item.target == 'true'?true:false;
		},
		
		//删除快捷链接
		delLink(){
			this.addLinkForm.dialog = false;
			request({
				ac:'setLink',
				type:'delLink',
				index:this.addLinkForm.index,
			},(res)=>{
				this.addLinkForm.dialog = false;
				if(res.sta == 1){
					this.userInfo.fastLink =res.data;
					$.cookie('bphp_userInfo',JSON.stringify(this.userInfo));
					ElementPlus.ElMessage({type: 'success',message: res.msg,});
				}else{
					ElementPlus.ElMessage({type: 'warning',message: res.msg,});
				}
			});
		},
	
		//分享
		share(obj){
			
			//分享文件
			let shareFile = {};
			if(obj.hasOwnProperty('c_name')){
				shareFile.fid = obj.cid;
				shareFile.name= obj.c_name+' (文件夹)';
				shareFile.fType = 'folder';
			}else{
				shareFile.fid = obj.id;
				shareFile.name= obj.name;
				shareFile.fType = 'file';
			}

			this.shareForm.file = shareFile;

			this.shareForm.dialog = true;
		},
		
		buildShare(){
			//表单验证
			let formEl = this.$refs.shareForm;
			formEl.validate((valid) => {
				if(valid){
					request({
						ac:'buildShare',
						fid:this.shareForm.file.fid,
						fType:this.shareForm.file.fType,
						outTime:this.shareForm.outTime,
						pass:this.shareForm.pass,
						type:this.shareForm.type,
						havePass:this.shareForm.havePass,
						integral:this.shareForm.integral,
						integralType:this.shareForm.integralType,
						freeGroupId:this.shareForm.freeGroupId,
					},(res)=>{
						//console.log(res);
						if(res.sta == 1){
							this.shareForm.dialog = false;
							ElementPlus.ElMessageBox.alert(res.html,'分享创建成功',{
								autofocus:false,
								dangerouslyUseHTMLString: true,
								confirmButtonText: res.btnText,
								customClass:'shareBox',
							}).then(() => {
								copyText(res.copyText);
								ElementPlus.ElMessage({type: 'success',message:'复制成功！'});
							}).catch(() => {})
						}
					});
				}else {
					console.log('error submit!');
				}
			});
		},
		
		//生成分享密码
		sharePass(){
			this.shareForm.pass = randomCode(6);
		},
		
		//文件大小文本
		sizeFormat(data){
			return sizeFormat(data);
		},
		//时间格式化
		timeFormat(time){
			return timeFormat(time);
		},
		
		//显示文件控制
		showFileCon(file){
			this.conFile = file;
			this.fileConBox = true;
		},
		

		//共享
		enjoy(obj){
			//分享文件
			let file = {};
			file.cid = obj.cid;
			file.name= obj.c_name;
			file.isEnjoy= obj.isEnjoy;
			this.enjoyForm.file = file;
			this.enjoyForm.obj = obj;
			
			this.enjoyForm.groupIds = [];
			this.enjoyForm.outTime = 30;
			
			//共享信息
			if(obj.isEnjoy == 1){
				request({
					ac:'enjoyInfo',
					cid: obj.cid
				},(res)=>{
					
					let data = res.data;
					
					//所有共享用户组名称
					let groupNames = [];
					res.data.groupIds.map(res=>{
						groupNames.push(this.siteInfo.usergroups[res].grouptitle);
					});
					groupNames =groupNames.join('，');
					data.groupNames = groupNames;
					
					
					this.enjoyForm.enjoyInfo = data;
					this.enjoyForm.groupIds = data.groupIds;
					this.enjoyForm.dialog = true;
					
					$('.enjoyDialog .el-alert--warning').show();

					console.log(this.enjoyForm.enjoyInfo);
				});
				
			}else{
				this.enjoyForm.enjoyInfo = {};
				this.enjoyForm.dialog = true;
			}
			
		},
		
		//生成共享
		buildEnjoy(){
			//表单验证
			let formEl = this.$refs.enjoyForm;
			formEl.validate((valid) => {
				if(valid){
					request({
						ac:'buildEnjoy',
						cid:this.enjoyForm.file.cid,
						groupIds:this.enjoyForm.groupIds,
						outTime:this.enjoyForm.outTime,
						cName:this.enjoyForm.file.name,
					},(res)=>{
						if(res.sta == 1){
							this.enjoyForm.dialog = false;
							ElementPlus.ElMessage({type: 'success',message:res.msg});
							$('.f-item[data-id="'+this.enjoyForm.file.cid+'"][data-type="classify"]').find('.thumb').attr('src','source/plugin/bphp_clouds/static/style/fileIcon/g-folder.png');
							this.enjoyForm.obj.isEnjoy = 1;
						}
					});
				}else {
					console.log('error submit!');
				}
			});
		},
		
		//取消共享
		cancelEnjoy(){
			request({
				ac:'cancelEnjoy',
				cid:this.enjoyForm.file.cid,
			},(res)=>{
				
				if(res.sta == 1){
					this.enjoyForm.dialog = false;
					ElementPlus.ElMessage({type: 'success',message:res.msg});
					$('.f-item[data-id="'+this.enjoyForm.file.cid+'"][data-type="classify"]').find('.thumb').attr('src','source/plugin/bphp_clouds/static/style/fileIcon/folder.png');
				
					this.enjoyForm.obj.isEnjoy = 0;
				}
			});
		},

		//文件属性
		info(file){
			this.fileInfo.file = file;
			this.fileInfo.dialog = true;
			console.log(file);
		},
		
		//修改列表样式
		setListStyle(val){
			this.listStyle = val;
			$.cookie('listStyle',val,{expires: 30});
		},

		//获取get参数
		getParam(){
			//文件类型
			this.type = getParam('type')||'all';
			//分类id
			this.cid = getParam('cid')||0;
			//搜索关键词
			this.searchKey = getParam('searchKey') ||'';
		}
		
	},
	
	async mounted(){
		
		//文件类型
		this.getParam();
		//监听get 参数变化，获取列表数据
		window.onpopstate = ()=>{   
			this.getParam();
			this.fileDisplay();
			console.log('更新列表了');
		};
		
		//获取插件配置
		this.config = await this.getConfig();
		
		
		//获取用户信息
		let getUser = await this.getUserInfo();
		if(getUser != 1){
			return false;
		}


		//文件列表
		this.fileDisplay();
		
		//获取网站信息
		this.getSiteInfo();
		
		//创建oss对象
		if(this.config.storageType == 'aliyun'){
			request({
				ac:'aliToken',
			},(res)=>{
				if(res.sta == 1){
					this.client = new OSS({
						accessKeyId: res.data.accessKeyId,
						accessKeySecret: res.data.accessKeySecret,
						stsToken: res.data.stsToken,
						bucket: res.data.bucket, 
						region: res.data.region, 
					});
					console.log(this.client);
				}else{
					ElementPlus.ElMessage({type: 'error',message: res.msg});
					console.log(res.errMsg);
				}
			});
		}
		

		//框选文件
		mobileMoveSel((fid,cid)=>{
			this.selFid = fid;
			this.selCid = cid;
		},this);
		
		//监听是否滚动到底了
		listenIsBottom((res)=>{
			this.loadMore();
		},'#fileArea');
		
		
		
		//长按
		$('.layout-main').on('touchstart', (e)=>{  
			var touch = e.originalEvent;  
			var touchTimer = setTimeout(()=>{  
				this.selCon = true; 
			}, 800); // 设置1秒作为长按时间  
		  
			$('.layout-main').on('touchend touchcancel', ()=>{  
				clearTimeout(touchTimer);  
			});
		});
		
		//判断是否在微信浏览器打开
		var ua = navigator.userAgent.toLowerCase();
		var isWeixin = ua.indexOf('micromessenger') != -1;
		if(isWeixin){
			this.isWeixin = true;
		}

		//列表样式
		if($.cookie('listStyle')){
			this.listStyle = $.cookie('listStyle');
		}else{
			this.listStyle  = this.config.listStyle;
		}

		
		//回车搜索
		document.getElementById('searchInput').addEventListener('keydown', (event)=>{  
			if (event.keyCode === 13) { // 13 是回车键的键码  
				event.preventDefault(); // 阻止默认行为，例如提交表单  
				this.search();
			}  
		});  

	},
	computed:{
		//预览图片列表
		showImglist(e){
			let imglist = [];
			this.fList.map((res)=>{
				if(['png','jpg','gif','jpeg','webp'].includes(res.type)){
					imglist.push(res.link);
				}
			});
			return imglist;
		},
		
		navList(){
			let nav = this.config.nav.split(/[\n\t\r]+/);
			let arr = [];
			nav.map((res)=>{
				arr.push(res.split('|'));
			});
			return arr;
		}
	}
};

const app = Vue.createApp(App);
app.use(ElementPlus);
app.use(vant);
app.mount("#app");




