
//ajax请求封装
request = function(data,callBack,type='',url='',showloading=''){
	if(type === ''){
		type='post';
	}
	if(url === ''){
		url='plugin.php?id=bphp_clouds:api'
	}
	if(showloading === ''){
		showloading = 1;
	}

	data.formhash = BPHP.formhash;
	$.ajax({
		type:type,
		url:url, 
		data:data,
		beforeSend:()=>{	
			if(showloading == 1){
				loading = ElementPlus.ElLoading.service({
					lock: true,
					background: 'rgba(255, 255, 255, 0.3)',
				});
			}
		},
		dataType:'json',
		success:(res)=>{
			loading.close();
			callBack(res);
		},
		error: function (XMLHttpRequest, textStatus, errorThrown) {
			console.log(errorThrown);
			loading.close();
			ElementPlus.ElMessage.error('请求出错了：'+errorThrown);
		}
	});
}

//获取get参数
getUrlParam = function(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) return decodeURI(r[2]);
	return null;
}


//获取当前日期
getDate = function(){
	const now = new Date();
	const year = now.getFullYear();
	const month = ('0' + (now.getMonth() + 1)).slice(-2);
	const day = ('0' + now.getDate()).slice(-2);
	return year + month + day;
}



//拖动文件
//callBack 回调方法
//id 元素id值
dropFile = function(callBack,id){
	var dropZone = document.querySelector(id);
	dropZone.addEventListener("dragenter", function (e) {e.preventDefault();e.stopPropagation();}, false);
	dropZone.addEventListener("dragover", function (e) {e.preventDefault();e.stopPropagation(); $(id).addClass('on');}, false);
	dropZone.addEventListener("dragleave", function (e) {e.preventDefault();e.stopPropagation(); }, false);
	dropZone.addEventListener("drop", function(e) {
		$(id).removeClass('on');
		e.preventDefault();
		e.stopPropagation();
		var df = e.dataTransfer||e.target;
		var dropFiles = []; // 拖拽的文件，会放到这里
		var dealFileCnt = 0; // 读取文件是个异步的过程，需要记录处理了多少个文件了
		var allFileLen = df.files.length; // 所有的文件的数量，给非Chrome浏览器使用的变量// 检测是否已经把所有的文件都遍历过了
		
		function checkDropFinish() {
			if (dealFileCnt === allFileLen - 1) {
				callBack(dropFiles,true,'');
			}
			dealFileCnt++;
		}
		if (df.items !== undefined) { // Chrome拖拽文件逻辑
			for (var i = 0; i < df.items.length; i++) {
				var item = df.items[i];
				if (item.kind === "file" && item.webkitGetAsEntry().isFile) {
					var file = item.getAsFile();
					dropFiles.push(file);
					checkDropFinish();
					//console.log(file);
				}else{
					callBack(dropFiles,false,'不支持上传文件夹');
					console.log('不支持上传文件夹');
				}
			}
		} else {
			// 非Chrome拖拽文件逻辑
			for (var i = 0; i < allFileLen; i++) {
				var dropFile = df.files[i];
				if (dropFile.type) {
					dropFiles.push(dropFile);
					checkDropFinish();
				} else {
					try {
						var fileReader = new FileReader();
						fileReader.readAsDataURL(dropFile.slice(0, 3));
						fileReader.addEventListener('load', function(e) {
							dropFiles.push(dropFile);
							checkDropFinish();
						}, false);
						fileReader.addEventListener('error', function(e) {
							callBack(dropFiles,false,'不支持上传文件夹');
							checkDropFinish();
						}, false);
					} catch (e) {
						callBack(dropFiles,false,'不支持上传文件夹');
						checkDropFinish();
					}
				}
			}
		}
	}, false);	
	
}


//粘帖文件
//callBack 回调方法
//id 元素id值
addPaste = function(callBack,id){
	var dropZone = document.querySelector(id);
	dropZone.addEventListener("paste", function(e) {
		if (!(e.clipboardData && e.clipboardData.items)) {
			return;
		}
		var files = [];
		for (var i = 0, len = e.clipboardData.items.length; i < len; i++) {
			var item = e.clipboardData.items[i];
			if (item.kind === "string") {
				callBack('',false,'请粘帖文件');
			}else if (item.kind === "file") {
				var blob = item.getAsFile();
				files.push(blob);
			}else{
				callBack('',false,'不支持上传文件夹');
			}
		 }
		callBack(files,true,'');
	}, false);	
	
}




// 本地文件上传方法
//vueFile 上传文件对象
//url 服务器请求地址
//cid 分类id
//callback 回调方法 返回josn  {sta:状态码,msg:提示信息,progress:上传进度,space: 上传速度，capacity：用户使用空间大小}
localUpfile = function(vueFile,url,cid,callback){
	let formhash = BPHP.formhash;
	let file = vueFile.source;
	let fileSize = file.size;
	let length = 1024 * 1024 * 2;   //这里是每一个分片的大小 2M起分
	let total_number = Math.ceil(file.size/length) //使用进一法, 来确定分片的个数
	let start = 0;			//分片的初始位置
	let end = length;		//分片的结束位置
	let index = 0; //第几个切片位置
	let fileName = Date.now()+file.name.substring(file.name.lastIndexOf(".")); //生成唯一文件名
	let checkTimeout = 0;

	//不分片上传
	if(total_number == 1){
		let formData = new FormData();  //创建一个FormData对象, 准备传送数据
		formData.append("ac",'upload');   //方法
		formData.append("cid",cid);   //分类id
		formData.append("flag",2);   //没有切片标记
		formData.append("formhash",formhash);   //表单验证
		formData.append("file",file);   //据分片数据放入 formData
		formData.append("rePath",vueFile.rePath);   //同名替换文件
		
		$.ajax({
			type:"post",
			url:url,  //后台上传文件的地址
			data:formData,
			beforeSend:()=>{
				sTtime =  new Date().getTime();
			},
			contentType: false,    //这个不能少, ajax上传文件是不能少的
			processData: false,	   //这个不能少, ajax上传文件必传 false
			dataType:'json',
			success:function(res){
				//上传速度
				var time = (new Date().getTime()+1-sTtime)/1000;
				var speed = sizeFormat(Math.trunc(file.size/time));
				
				if(res.sta == 1){
					callback({sta:'success',msg:'上传成功',url:res.src,progress:'100%',speed:speed,'capacity':res.capacity});
				}else{
					callback({sta:'failed',msg:res.msg,progress:'0%'});
				}
			},
			error: function (e) {
				callback({sta:'failed',msg:'上传错误',progress:'0%'});
			}
		})
		
		return false;
	}

	
	//提取分片数据
	function partData(index){
		//这里开始分片, 并且把每一个分片上传到服务器
		let blob = file.slice(start,end);  //得到一个分片
		
		start = end;				//调整下一个分片的起始位置
		end = start+length;			//调整下一个分片的结束位置
		if(end > file.size){
			end = file.size;		//这里对最后的一个分片结束位置进行调整
		}

		let formData = new FormData();  //创建一个FormData对象, 准备传送数据
		if(index == total_number-1){
			formData.append("isLastPar",1); 
		}else{
			formData.append("isLastPar",0); 
		}
		
		formData.append("ac",'upload');   //方法
		formData.append("cid",cid);   //分类id
		formData.append("flag",1);   //分片上传标记
		formData.append("formhash",formhash);   //表单验证
		formData.append("file",blob);   //据分片数据放入 formData
		formData.append("blobSize",blob.size);   //切片大小
		formData.append("fileName",fileName);  //时间戳文件名
		formData.append("originName",file.name);  //原始文件名
		formData.append("rePath",vueFile.rePath);   //同名替换源文件名
		return formData;
	}
	
	
	//上传切片
	function pro(formData){
		//取消上传，清除已上传切片
		var stopUp = $('.stopUp').val();
		if(stopUp == 'true'){
			$.ajax({
				type:'post',
				url:url,  //后台上传文件的地址
				data:{
					ac:'delpro',
					formhash:formhash,
					fileName:fileName
				},
				dataType:'json',
				success : function(data){
					console.log(data);
				}
			});
			return false;
		}

		var blobSize = formData.get('blobSize'); //切片文件大小

		$.ajax({
			type:"post",
			url:url,  //后台上传文件的地址
			beforeSend:()=>{
				sTtime =  new Date().getTime();
			},
			data:formData,
			contentType: false,    //这个不能少, ajax上传文件是不能少的
			processData: false,	   //这个不能少, ajax上传文件必传 false
			dataType:'json',
			success:function(res){
				if(res.sta == 1){
					var progress = Math.trunc((index*length+blobSize*1)/fileSize*100)+'%'; //进度百分比
					index = index + 1;
					
					//上传速度
					var time = (new Date().getTime()+1-sTtime)/1000;
					var speed = sizeFormat(Math.trunc(blobSize/time));

					callback({sta:'progress',msg:progress,progress:progress,speed:speed});
					
					if(index >= total_number){
						callback({sta:'success',msg:'上传成功',url:res.src,progress:'100%','capacity':res.capacity});
					}else{
						var formData = partData(index);
						pro(formData);
					}
					
				}else{
					callback({sta:'failed',msg:res.msg,progress:'0%'});
				}
			},
			error: function (e) {
				callback({sta:'failed',msg:'上传错误',progress:'0%'});
			}
		})
	}
	
	//启动上传
	var formData = partData(index);
	pro(formData);
}


// 阿里云文件上传方法
//vueFile 上传文件对象
//url 服务器请求地址
//cid 分类id
//callback 回调方法 返回josn  {sta:状态码,msg:提示信息,progress:上传进度}
aliyunUpfile = async function(vueFile,url,cid,callback,client){
	var file = vueFile.source;
	var uid =  BPHP.uid;
	var rePath = vueFile.rePath;
	if(vueFile.rePath != ''){
		//文件替换
		var path = '/bphpClouds/'+uid+'/'+rePath.split('/'+uid+'/')[1];
	}else{
		var soruceName = hex_md5(Date.now()+file.name)+file.name.substring(file.name.lastIndexOf(".")); //生成唯一文件名
		var path = '/bphpClouds/'+uid+'/'+getDate()+'/'+soruceName;
	}
	
	try{
		//2M以内不分片
		if(file.size < 1024 * 1024*2){
			var sTtime = new Date().getTime();
			const result = await client.put(path,file);
			
			//上传速度
			var time = (new Date().getTime()+1-sTtime)/1000;
			var speed = sizeFormat(Math.trunc(vueFile.source.size/time));
			var url = result.url;
		}else{
			var sTtime = new Date().getTime();
		
			// 设置中断点。
			let abortCheckpoint
			const abort = document.getElementById("abort");
		    abort.addEventListener("click", () => {
				client.abortMultipartUpload(abortCheckpoint.name,abortCheckpoint.uploadId);
		    });

			var result = await client.multipartUpload(path,file,{
				// 获取分片上传进度、断点和返回值。
				progress: (p, cpt, res) => {
					console.log(p,);
					abortCheckpoint = cpt;
					
					if(p>0){
						//进度百分比
						var progress = Math.trunc(p*100)+'%'; 
						//上传速度
						var time = (new Date().getTime()+1-sTtime)/1000;
						var speed = sizeFormat(Math.trunc(vueFile.source.size/time));
						
						callback({sta:'progress',msg:progress,progress:progress,speed:speed});
					}
				},
				parallel: 4,// 设置并发上传的分片数量。
				partSize: 1024 * 1024, // 设置分片大小。默认值为1 MB，最小值为100 KB。
				mime: "text/plain",
				timeout: 120000  // 设置超时时间120000
			});
			var url = result.res.requestUrls[0].split('?')[0];
			
		}
	}catch(err){
		$.cookie('aliyuntoken-'+uid, null);
		callback({sta:'failed',msg:'上传失败',progress:'0%'});
		return false;
    }
	
	request({
		ac:'upload',
		cid:cid,
		aliyunPath:url,
		fileSize:file.size,
		fileName:file.name,
		rePath:rePath,
	},(res)=>{
		if(res.sta == 1){
			callback({sta:'success',msg:res.msg,url:url,speed:speed,progress:'100%','capacity':res.capacity});
		}else{
			callback({sta:'failed',msg:res.msg,progress:'0%'});
		}
		
	},'','',false);

}


// 七牛云文件上传方法
//vueFile 上传文件对象
//url 服务器请求地址
//cid 分类id
//callback 回调方法 返回josn  {sta:状态码,msg:提示信息,progress:上传进度}
qiniuUpfile = async function(vueFile,url,cid,callback){
	var file = vueFile.source;
	var uid =  BPHP.uid;
	var rePath = vueFile.rePath;
	//文件替换
	if(rePath != ''){
		var path = 'bphpClouds/'+uid+'/'+rePath.split('/'+uid+'/')[1];
	}else{
		var soruceName = hex_md5(Date.now()+file.name)+file.name.substring(file.name.lastIndexOf(".")); //生成唯一文件名
		var path = 'bphpClouds/'+uid+'/'+getDate()+'/'+soruceName;
	}
	
	
	//七牛云token
	var token = await new Promise(resolve => {
		request({
			ac:'qinuiToken',
			key:path
		},(res)=>{
			resolve(res);
		},'','',false);
	});
	
	if(token.sta == 0){
		callback({sta:'failed',msg:token.msg,progress:'0%'});
		return false;
	}
	
	
	var speed = 0; //速度
	var preLoaded = 0; //上次已上传大小
	var sTtime = new Date().getTime();// 上传开始时间
	
	const observable = qiniu.upload(file, path, token.data, {}, {});
	
	const subscription = observable.subscribe((res)=>{
		
		//进度百分比
		var progress = Math.trunc(res.total.percent)+'%'; 
		//上传速度
		var time = (new Date().getTime()-sTtime)/1000; //秒
		
		speed = sizeFormat(Math.trunc((res.total.loaded-preLoaded)/time));
		
		callback({sta:'progress',msg:progress,progress:progress,speed:speed});

		sTtime = new Date().getTime();
		preLoaded = res.total.loaded;

	},(res)=>{
		
	},(res)=>{
		//上传记录
		request({
			ac:'upload',
			cid:cid,
			path:res.key,
			fileSize:file.size,
			fileName:file.name,
			rePath:rePath,
		},(res)=>{
			if(res.sta == 1){
				callback({sta:'success',msg:res.msg,url:url,progress:'100%','capacity':res.capacity});
			}else{
				callback({sta:'failed',msg:res.msg,progress:'0%'});
			}
			
		},'','',false);
	});
	
	
	//中断按钮
	$('#abort').on('click', () => {
		console.log('上传取消');
		subscription.unsubscribe() // 上传取消
	})
		
}


//文件大小文本
sizeFormat = function(size){
	//console.log(size);
	if(size<1024*1024){
		return Math.ceil(size/1024)+'KB';
	}
	if(size>=1024*1024 && size<1024*1024*1024){
		return Math.ceil(size/1024/1024*100)/100+'MB';
	}
	return Math.ceil(size/1024/1024/1024*100)/100+'G';
}


//框选文件
moveSel = function(callBack){
	document.getElementById("fileArea").onmousedown = function(e) {
		
		//删除残留选择框
		if(document.getElementById('selectDiv')){
			let self = document.getElementById('selectDiv');
			let parent = self.parentElement;
			parent.removeChild(self);
		}

		var selAre = e.target.getAttribute('data-ele');
		if(selAre == 'selAre'){  //限定元素可选属性

			let boxList = [];
			// getElementsByTagName返回带有指定标签名的对象的集合
			let boxes = document.getElementsByClassName("f-item");
			//console.log(boxes);
			for (let i = 0; i < boxes.length; i++) {
				boxList.push(boxes[i]);
			}
			let isSelect = true;
			// 获取事件触发后的event对象，做了一个兼容性处理
			let evt = window.event || arguments[0];
			// 存放鼠标点击初始位置
			let startX = (evt.x || evt.clientX);
			let startY = (evt.y || evt.clientY);  

			// 创建一个框选元素
			let selDiv = document.createElement("div");
			// 给框选元素添加css样式，使用绝对定位
			selDiv.style.cssText = "position:absolute;  width:0px; height:0px; font-size:0px; margin:0px;background-color:#70cafc; padding:0px; border:1px solid #0099FF; z-index:1000; filter:alpha(opacity:60); opacity:0.3; display:none";
			// 添加ID
			selDiv.id = "selectDiv";
			// appendChild()向节点添加最后一个子节点
			document.body.appendChild(selDiv);
			// 根据起始位置，添加定位
			selDiv.style.left = startX + "px";
			selDiv.style.top = startY + "px";

			// 根据坐标给选框修改状态
			let _x = null;
			let _y = null;
			// 移动鼠标
			document.onmousemove = function() {
				evt = window.event || arguments[0];
				if (isSelect) {
					if (selDiv.style.display == "none") {
						selDiv.style.display = "";
					}
					// 获取当前鼠标位置
					_x = (evt.x || evt.clientX);
					_y = (evt.y || evt.clientY);
					selDiv.style.left = Math.min(_x, startX) + 'px';
					selDiv.style.top = Math.min(_y, startY) + 'px';
					selDiv.style.width = Math.abs(_x - startX) + 'px';
					selDiv.style.height = Math.abs(_y - startY) + 'px';
				
					//区域偏移位置
					let scrollTop = document.getElementById('fileArea').scrollTop;
					let area_l = document.getElementById('fileArea').getBoundingClientRect().left;
					
					
					
					let _l = selDiv.offsetLeft*1-area_l; 
					let _t = selDiv.offsetTop+scrollTop;
					let _w = selDiv.offsetWidth;
					let _h = selDiv.offsetHeight;
					
					let selFid =[];
					let selCid =[];
					for (let i = 0; i < boxList.length; i++) {
						let sl = boxList[i].offsetWidth + boxList[i].offsetLeft;
						let st = boxList[i].offsetHeight + boxList[i].offsetTop;

						if (sl > _l && st > _t && boxList[i].offsetLeft < _l + _w && boxList[i].offsetTop < _t + _h) {
							let type = boxList[i].getAttribute('data-type');
							if(type == 'file'){ //文件id
								selFid.push(boxList[i].getAttribute('data-id'));
							}
							if(type == 'classify'){ //分类id
								selCid.push(boxList[i].getAttribute('data-id'));
							}
						}
					}
					callBack(selFid,selCid);
				}
			}

			// 放开鼠标，选框消失
			document.onmouseup = function () {
				isSelect = false;
				if (selDiv) {
					document.body.removeChild(selDiv);
				}

				boxList = null, _x = null, _y = null, selDiv = null, startX = null, startY = null, evt = null;
			}

			
		}
	}
}


//手机端框选文件
mobileMoveSel = function(callBack,t){
	document.getElementById("fileArea").addEventListener('touchstart',function(e) {
		//删除残留选择框
		if(document.getElementById('selectDiv')){
			let self = document.getElementById('selectDiv');
			let parent = self.parentElement;
			parent.removeChild(self);
		}
		//console.log(e.target.getAttribute('class'));
		//限定元素区域
		if(t.selCon){  
			
			//限定元素区域
			var selAre = e.target.getAttribute('data-ele');
			if(selAre != 'selAre'){
				return ;
			}
		
			let boxList = [];
			// getElementsByTagName返回带有指定标签名的对象的集合
			let boxes = document.getElementsByClassName("f-item");
			//console.log(boxes);
			for (let i = 0; i < boxes.length; i++) {
				boxList.push(boxes[i]);
			}
			let isSelect = true;
			// 获取事件触发后的event对象，做了一个兼容性处理
			let evt = event.targetTouches[0];
			// 存放鼠标点击初始位置
			let startX = (evt.pageX || evt.clientX);
			let startY = (evt.pageY || evt.clientY);  

			// 创建一个框选元素
			let selDiv = document.createElement("div");
			// 给框选元素添加css样式，使用绝对定位
			selDiv.style.cssText = "position:absolute;  width:0px; height:0px; font-size:0px; margin:0px;background-color:#70cafc; padding:0px; border:1px solid #0099FF; z-index:1000; filter:alpha(opacity:60); opacity:0.3; display:none";
			// 添加ID
			selDiv.id = "selectDiv";
			// appendChild()向节点添加最后一个子节点
			document.body.appendChild(selDiv);
			// 根据起始位置，添加定位
			selDiv.style.left = startX + "px";
			selDiv.style.top = startY + "px";

			// 根据坐标给选框修改状态
			let _x = null;
			let _y = null;
			// 移动鼠标
			document.addEventListener('touchmove',function() {
				console.log('touchmove');
				evt = event.targetTouches[0];
				//console.log(evt.pageX);
				if (isSelect) {
					if (selDiv.style.display == "none") {
						selDiv.style.display = "";
					}
					// 获取当前鼠标位置
					_x = (evt.pageX || evt.clientX);
					_y = (evt.pageY || evt.clientY);
					
					selDiv.style.left = Math.min(_x, startX) + 'px';
					selDiv.style.top = Math.min(_y, startY) + 'px';
					selDiv.style.width = Math.abs(_x - startX) + 'px';
					selDiv.style.height = Math.abs(_y - startY) + 'px';
					
					
					let scrollTop = document.getElementById("fileArea").scrollTop;
					let _l = selDiv.offsetLeft; 
					let _t = selDiv.offsetTop+scrollTop;
					let _w = selDiv.offsetWidth;
					let _h = selDiv.offsetHeight;
					
					let selFid =[];
					let selCid =[];
					for (let i = 0; i < boxList.length; i++) {
						let sl = boxList[i].offsetWidth + boxList[i].offsetLeft;
						let st = boxList[i].offsetHeight + boxList[i].offsetTop;

						if (sl > _l && st > _t && boxList[i].offsetLeft < _l + _w && boxList[i].offsetTop < _t + _h) {
							let type = boxList[i].getAttribute('data-type');
							if(type == 'file'){ //文件id
								selFid.push(boxList[i].getAttribute('data-id'));
							}
							if(type == 'classify'){ //分类id
								selCid.push(boxList[i].getAttribute('data-id'));
							}
						}
					}
					callBack(selFid,selCid);
				}
			});

			// 放开鼠标，选框消失
			document.addEventListener('touchend',function () {
				console.log('touchend');
				isSelect = false;
				if (selDiv) {
					document.body.removeChild(selDiv);
				}
				boxList = null, _x = null, _y = null, selDiv = null, startX = null, startY = null, evt = null;
			});
		}
	
	});
}


//监听文件列表是否到底
listenIsBottom = function(callBack,obj){
	$(obj).scroll(function() {
		
		var documentHeight = $(document).height();
		var box_t = $('#add_more').offset().top;
		var box_h = $('#add_more').height();
		if((box_t + box_h) <= documentHeight) {
			callBack();
		}
	});

}

//复制文件
copyText = function(text) {
	var input = document.createElement("textarea"); // 创建input对象
	input.value = text; // 设置复制内容
	document.body.appendChild(input); // 添加临时实例
	input.select(); // 选择实例内容
	document.execCommand("Copy"); // 执行复制
	document.body.removeChild(input); // 删除临时实例
}

//判断是否为链接
checkLink = function(rule, value, callback){
	var patt=/^https?:\/\//;
	if(!patt.test(value)){
		callback(new Error('链接地址不正确'));
	}else{
		callback();
	}
}


//验证正整数
checkInt = function(rule, value, callback){
	var patt=/^[0-9]+$/;
	if(!patt.test(value)){
		callback(new Error('请输入一个正整数'));
	}else{
		callback();
	}
}
//提取码格式验证
checkPass = function(rule, value, callback){
	var patt=/\|/;
	if(patt.test(value)){
		callback(new Error('提取密码不得包含 "|" 字符'));
	}else{
		callback();
	}
}

// 生成随机数
// @param {Number} len 生成的文件名长度
// @param {Number} radix 指定基数
randomCode = function(len, radix) {
	var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('')
	var uuid = []
	var i = 0
	radix = radix || chars.length
	if (len) {
	for (i = 0; i < len; i++) uuid[i] = chars[0 | Math.random() * radix]
	} else {
	var r
	uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-'
	uuid[14] = '4'

	for (i = 0; i < 36; i++) {
	  if (!uuid[i]) {
		r = 0 | Math.random() * 16
		uuid[i] = chars[(i === 19) ? (r & 0x3) | 0x8 : r]
	  }
	}
	}

	return uuid.join('')
}


//是否为微信浏览器
isWeChatBrowser = function isWeChatBrowser() {  
  var ua = navigator.userAgent || navigator.vendor || window.opera;  
  return ua.indexOf('WeChat') > -1 || ua.indexOf('MicroMessenger') > -1;  
}  

//php time()  时间格式化
timeFormat = function(time){
	var currentTime = new Date(time*1000); 
	var formattedTime = currentTime.getFullYear() + '-' +  
    ('0' + (currentTime.getMonth() + 1)).slice(-2) + '-' +  
    ('0' + currentTime.getDate()).slice(-2) + ' ' +  
    ('0' + currentTime.getHours()).slice(-2) + ':' +  
    ('0' + currentTime.getMinutes()).slice(-2) + ':' +  
    ('0' + currentTime.getSeconds()).slice(-2);  
	return formattedTime;
}



//指定div滚动条下滑一定高度
//obj div对象
//height 下滑高度
divScrollTo = function(obj,height){
	var myDiv = $(obj);
	var scrollTop = myDiv.scrollTop();
	myDiv.animate({scrollTop: scrollTop + height}, 100);
}

//获取#号后面的参数
getParam = function(name){
	var searchParams = new URLSearchParams(window.location.hash.slice(1)); // 去除前面的#号  
	return searchParams.get(name); 
}

//判断是否为手机端
isMobile = function isMobile() {  
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;  
    return /Mobile|iP(hone|od)|Android/i.test(userAgent);  
}  